
#include "ad++.h"

const int N = 8 ;

int main(int argc, char** argv) {
  AdlibInit(argc, argv) ;

  Procs1 p(4) ;
  ON(p) {
    CyclicRange x(N, p.dim(0)) ;

    // Initialization

    Array2SD<float> a(N, x) ;
    Array1S<float> b(N) ;  // buffer

    Index m(x) ;
    OVERALL(m) {
      for(int i = 0 ; i < N ; i++)
        if (m >= i)
          a(i, m) = i + 1 ;
        else
          a(i, m) = m + 1 ;
    } ALLOVER(i) ;

    gprintf("initial a:\n") ;
    aprintf("%7.3f%*N", a, N) ;

    // Do decomposition

    for(int k = 0 ; k < N - 1 ; k++) {

      Location l = x(k) ;
      AT(l) {
        const float d = sqrt(a(k, l)) ;

        a(k, l) = d ;
        for(int s = k + 1 ; s < N ; s++)
          a(s, l) /= d ;
      } TA(l) ;

      remap(b.sect(Trip(k + 1)), a.sect(Trip(k + 1), x(k))) ;

      Index2 m(x, N - k - 1, k + 1) ;
      OVERALL(m) {
        for(int i = k + 1 + m ; i < N ; i++)
          a(i, m) -= b(i) * b((int) m) ;
      } ALLOVER(m) ;

      gprintf("after iteration %d:\n", k) ;
      aprintf("%7.3f%*N", a, N) ;
    }

    Location l = x(N - 1) ;
    AT(l) {
      a(N - 1, l) = sqrt(a(N - 1, l)) ;
    } TA(l) ;

    gprintf("final a:\n") ;
    aprintf("%7.3f%*N", a, N) ;

  } NO(p) ;

  AdlibFinalize() ;
}

