
#include "ad++.h"

void read_image(char* filename, const Section2<int>& image,
                int* nx, int* ny, int* maxin) ;

void read_image(char* filename, const Section2<int>& image,
                int* nx, int *ny, int *maxin) {

// _____________________________________________________________________
//|                                                                     |
//| Subroutine, to read in a .pgm format image from file, into an       |
//| integer array.                                                      |
//|                                                                     |
//| H W Yau.  14th of February, 1994.                                   |
//| Northeast Parallel Architectures Center.                            |
//| Syracuse University.                                                |
//|_____________________________________________________________________|
//|                                                                     |
//| Edit record:                                                        |
//| 14/Feb/1995: Copied from Guy and Ken's wavelet code.  Hon-ie-fied.  |
//|_____________________________________________________________________|

// .. Local variables ..

  Range x = image.rng(0), y = image.rng(1) ;
  char magic [2] ;

// Read simple image from a file.

  FILE* ifile = gfopen(filename, "r") ;

  gfscanf(ifile, "%2s%d%d%d", magic, nx, ny, maxin) ;
  gprintf("Reading image %s of size %6d by %6d pixels Max intensity =%6d\n",
          filename, *nx, *ny, *maxin) ;

  afscanf(ifile, "%d", image.sect(Trip(0, *nx - 1), Trip(0, *ny - 1))) ;

  gfclose(ifile) ;
}

