
#include "stdio.h"

#include "ad++.h"

void write_image(char* filename, const Section2<int>& image,
                 int nx, int ny, int maxin) {

// _____________________________________________________________________
//|                                                                     |
//| Subroutine, to write a .pgm format file, from an integer array.     |
//|                                                                     |
//| H W Yau.  14th of February, 1994.                                   |
//| Northeast Parallel Architectures Center.                            |
//| Syracuse University.                                                |
//|_____________________________________________________________________|
//|                                                                     |
//| Edit record:                                                        |
//| 14/Feb/1995: Copied from Guy and Ken's wavelet code.  Hon-ie-fied.  |
//|_____________________________________________________________________|

// .. Local variables ..

  Range x = image.rng(0), y = image.rng(1) ;

// Write out image into file.

  gprintf("Writing image %s of size %6d by %6d pixels Max intensity = %6d\n",
          filename, nx, ny, maxin) ;

  FILE* ifile = gfopen(filename, "w") ;

  gfprintf(ifile, "P2\n%d %d\n%d\n", nx, ny, maxin) ;

  afprintf(ifile, "%3d %17N", image.sect(Trip(0, nx - 1), Trip(0, ny - 1))) ;

  gfclose(ifile) ;
}

