/*
 * File         : Array4Type.in.java
 * Author       : Guansong Zhang
 * Created      : Tue Nov  4 20:28:05 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/04/07 19:40:24 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Array4@Type@ extends Section4 {
  
  public Array4@Type@(Range r0, Range r1, Range r2, Range r3, Group group) {
    super(@key@); // for @Type@

    this.group=group;

    this.range[0]=r0;
    this.range[1]=r1;
    this.range[2]=r2;
    this.range[3]=r3;

    /* debug
    this.range[0].show("range0");
    this.range[1].show("range1");
    this.range[2].show("range2");
    this.range[3].show("range3");
    */

    int size=1;
    this.stride[0] = this.range[0].stride(size);
    this.stride[1] = this.range[1].stride(this.stride[0].size);
    this.stride[2] = this.range[2].stride(this.stride[1].size);
    this.stride[3] = this.range[3].stride(this.stride[2].size);
    size=this.stride[3].size;

    /* debug
    this.stride[0].show("stride0");
    this.stride[1].show("stride1");
    this.stride[2].show("stride2");
    this.stride[3].show("stride3");
    */

    //System.out.println("size is " + size); //debug 
    
    DAD dad=new DAD(group, this.range, this.stride);

    this.dad=dad;

    this.offset=0;

    data=new @type@[size];

    this.reference=data;

  }

//   public Array4@Type@(Range r0, Range r1, Range r2, Range r3) {
//     this(r0, r1, r2, r3, Spmd.apg);
//   }

  public Array4@Type@(Section4 sec) {
    super(@key@); // for @Type@

    this.group=sec.group;

    this.range[0]=sec.range[0];
    this.range[1]=sec.range[1];
    this.range[2]=sec.range[2];
    this.range[3]=sec.range[3];

    this.stride[0]=sec.stride[0];
    this.stride[1]=sec.stride[1];
    this.stride[2]=sec.stride[2];
    this.stride[3]=sec.stride[3];

    this.dad=sec.dad;

    this.offset=sec.offset;
    this.reference=sec.reference;

    this.data=(@type@[])sec.reference;
  }

  public Array0@Type@ section(Location loc0, Location loc1, Location loc2, Location loc3) {
    Section0 sec=this.subsec(loc0, loc1, loc2, loc3);

    Array0@Type@ array=new Array0@Type@(sec);

    return array;
  }

  public Array1@Type@ section(Range rng0, Location loc1, Location loc2, Location loc3) {
    Section1 sec=this.subsec(rng0, loc1, loc2, loc3);

    Array1@Type@ array=new Array1@Type@(sec);

    return array;
  }

  public Array1@Type@ section(Location loc0, Range rng1, Location loc2, Location loc3) {
    Section1 sec=this.subsec(loc0, rng1, loc2, loc3);

    Array1@Type@ array=new Array1@Type@(sec);

    return array;
  }

  public Array1@Type@ section(Location loc0, Location loc1, Range rng2, Location loc3) {
    Section1 sec=this.subsec(loc0, loc1, rng2, loc3);

    Array1@Type@ array=new Array1@Type@(sec);

    return array;
  }

  public Array1@Type@ section(Location loc0, Location loc1, Location loc2, Range rng3) {
    Section1 sec=this.subsec(loc0, loc1, loc2, rng3);

    Array1@Type@ array=new Array1@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Range rng0, Range rng1, Location loc2, Location loc3) {
    Section2 sec=this.subsec(rng0, rng1, loc2, loc3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Range rng0, Location loc1, Range rng2, Location loc3) {
    Section2 sec=this.subsec(rng0, loc1, rng2, loc3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Range rng0, Location loc1, Location loc2, Range rng3) {
    Section2 sec=this.subsec(rng0, loc1, loc2, rng3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Location loc0, Range rng1, Range rng2, Location loc3) {
    Section2 sec=this.subsec(loc0, rng1, rng2, loc3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Location loc0, Range rng1, Location loc2, Range rng3) {
    Section2 sec=this.subsec(loc0, rng1, loc2, rng3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array2@Type@ section(Location loc0, Location loc1, Range rng2, Range rng3) {
    Section2 sec=this.subsec(loc0, loc1, rng2, rng3);

    Array2@Type@ array=new Array2@Type@(sec);

    return array;
  }

  public Array3@Type@ section(Range rng0, Range rng1, Range rng2, Location loc3) {
    Section3 sec=this.subsec(rng0, rng1, rng2, loc3);

    Array3@Type@ array=new Array3@Type@(sec);

    return array;
  }
  
  public Array3@Type@ section(Range rng0, Range rng1, Location loc2, Range rng3) {
    Section3 sec=this.subsec(rng0, rng1, loc2, rng3);

    Array3@Type@ array=new Array3@Type@(sec);

    return array;
  }

  public Array3@Type@ section(Range rng0, Location loc1, Range rng2, Range rng3) {
    Section3 sec=this.subsec(rng0, loc1, rng2, rng3);

    Array3@Type@ array=new Array3@Type@(sec);

    return array;
  }

  public Array3@Type@ section(Location loc0, Range rng1, Range rng2, Range rng3) {
    Section3 sec=this.subsec(loc0, rng1, rng2, rng3);

    Array3@Type@ array=new Array3@Type@(sec);

    return array;
  }

  public Array4@Type@ section(Range rng0, Range rng1, Range rng2, Range rng3) {
    Section4 sec=this.subsec(rng0, rng1, rng2, rng3);

    Array4@Type@ array=new Array4@Type@(sec);

    return array;
  }

  public @type@ data[];

  public String toString() {
    return ("this is array4");
  }

};

