/*
 * File         : Section1.java
 * Author       : Guansong Zhang
 * Created      : Sun Oct 26 18:44:40 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/02/10 23:12:20 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Section1 extends Section {
  
  Section1 (int type) {
    super(1, type); 
    
    this.range=new Range[1];
    this.stride=new Stride[1];

  }

  public int element(Location loc) {
    return (this.offset+stride[0].offset(loc));
  }

  public Section0 subsec(Location loc) {

    Section0 sec=new Section0(this.type);

    sec.group=this.group.divide(loc);

    DAD dad=new DAD(sec.group);
    sec.dad=dad;

    sec.offset=this.offset+this.stride[0].offset(loc);

    sec.reference=this.reference;

    return sec;      
  }

  public Section1 subsec(Range range) {
    Section1 sec=new Section1(this.type);

    sec.group=this.group;    

    sec.range[0]=range;
    sec.stride[0]=this.stride[0];

    DAD dad=new DAD(sec.group, sec.range, sec.stride);
    sec.dad=dad;

    sec.offset=this.offset;

    sec.reference=this.reference;

    return sec;
  }

}
