/*
 * File         : Shift.java
 * Author       : Guansong Zhang
 * Created      : Tue Nov  4 20:40:55 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/30 17:53:10 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Shift extends InterfaceObject {
  
  private static native void init();
  public static native void clean();

  private native void constructor(DAD dst, DAD src, int len, int shift, int dim, int mode); 

  public Shift(DAD dst, DAD src, int _type, int shift, int dim, int mode) {
    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6: 
      len=4;
      constructor(dst, src, len, shift, dim, mode);
      break;
    default:
      System.out.println("not finished");

    };
  };

  public native void finalize();


  private native void execute(int[] dst, long dOffset, int[] src, long sOffset);
  private native void execute(float[] dst, long dOffset, float[] src, long sOffset);
   
  public void execute(Object dst, long dOffset, Object src, long sOffset) {
    
    switch (this.type) {

    case 4: {
      execute((int[])dst, dOffset, (int[])src, sOffset); 
      break;
    }

    case 6: {
      execute((float[])dst, dOffset, (float[])src, sOffset); 
      break;
    }

    default:
      System.out.println("not finished");
      break;
    }

  };

  public int type;

  static {
    init();
  }

}
