/*
 * File         : WriteHalo.java
 * Author       : Guansong Zhang
 * Created      : Thu Jan 22 10:48:19 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/30 17:53:12 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

package spmd;

import spmd.*;

public class WriteHalo extends InterfaceObject {

  private static native void init();
  public static native void clean();

  private native void constructor(DAD src, int len, int[] wlo, int[] whi, int[] mode);
  private native void constructor(DAD src, int len, int[] wlo, int[] whi);

  public WriteHalo(DAD src, int _type, int[] wlo, int[] whi, int[] mode) {

    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6:
      len=4;
      constructor(src, len, wlo, whi, mode);
      break;
    default:
      System.out.println("not finished");
    }
  }

  public WriteHalo(DAD src, int _type, int[] wlo, int[] whi) {

    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6:
      len=4;
      constructor(src, len, wlo, whi);
      break;
    default:
      System.out.println("not finished");
    }
  }

  private native void execute(boolean[] src, long sOffset);
  private native void execute(byte[] src, long sOffset);
  private native void execute(char[] src, long sOffset);
  private native void execute(short[] src, long sOffset);
  private native void execute(int[] src, long sOffset);
  private native void execute(long[] src, long sOffset);
  private native void execute(float[] src, long sOffset);
  private native void execute(double[] src, long sOffset);

  public void execute(Object src, long sOffset) {

    switch (this.type) {

    case 4: {
      execute((int[])src, sOffset); 
      break;
    }

    case 6: {
      execute((float[])src, sOffset); 
      break;
    }

    default:
      System.out.println("not finished");
      break;
    }
  }

  public int type;

  static {
    init();
  }

}
