/*
 * File         : spmd_BlockRange.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 13 12:06:49 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/07/08 16:43:02 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "spmd_BlockRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Dimension> spmd_Dimension_Table;
extern jctable<Range> spmd_Range_Table;

Range *spmd_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
BlockRange * spmd_BlockRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((BlockRange *)spmd_Range_ResolvePtr(env, jthis));
}

/*
 * Class:     spmd_BlockRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_BlockRange_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("spmd/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
};

/*
 * Class:     spmd_BlockRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_BlockRange_clean
  (JNIEnv *, jclass);

/*
  Layout int2emu(int i){
  switch (i) {
  case 0: 
    return (LAY_STANDARD);
    break;
  case 1: 
    return (LAY_PACKED);
    break;
  case 2: 
    return (LAY_ADAPT);
    break;
  case 3: 
    return (LAY_EXTENDED);
    break;
  default:
    break;
  }

  return(LAY_STANDARD);
}
*/

/*
 * Class:     spmd_BlockRange
 * Method:    constructor
 * Signature: (Lspmd/Range;II)V
 */
// JNIEXPORT void JNICALL Java_spmd_BlockRange_constructor__Lspmd_Range_2II
//   (JNIEnv *env, jobject jthis,jobject ker,jint blockSize,jint layout)
// {
//   BlockRange *cppBlockRange=new BlockRange(*spmd_Range_ResolvePtr(env,ker),blockSize,int2emu(layout));

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (spmd_Range_Table.ObjPtr[pos]);

// //  spmd_Range_ObjPtr[pos]=cppBlockRange;
//   spmd_Range_Table.ObjPtr[pos]=cppBlockRange;
  
//   //printf("the range pointer is %x\n", cppBlockRange); //debug

//   if (spmd_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }

// }

/*
 * Class:     spmd_BlockRange
 * Method:    constructor
 * Signature: (Lspmd/Range;IIII)V
 */
// JNIEXPORT void JNICALL Java_spmd_BlockRange_constructor__Lspmd_Range_2IIII
//   (JNIEnv * env, jobject jthis, jobject ker, jint blockSize, jint layout, jint wlo, jint whi)
// {

//   BlockRange *cppBlockRange=new BlockRange(*spmd_Range_ResolvePtr(env,ker),blockSize,int2emu(layout),wlo,whi);

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (spmd_Range_Table.ObjPtr[pos]);

// //  spmd_Range_ObjPtr[pos]=cppBlockRange;
//   spmd_Range_Table.ObjPtr[pos]=cppBlockRange;
 
//   if (spmd_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }
// };

/*
 * Class:     spmd_BlockRange
 * Method:    constructor
 * Signature: (ILspmd/Range;I)V
 */
JNIEXPORT void JNICALL Java_spmd_BlockRange_constructor__ILspmd_Range_2I
  (JNIEnv * env, jobject jthis, jint extent, jobject ker, jint layout)
{

  BlockRange *cppBlockRange=new BlockRange(extent, spmd_Range_ResolvePtr(env,ker)->dim());

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Range_Table.ObjPtr[pos]);

//  spmd_Range_ObjPtr[pos]=cppBlockRange;
  spmd_Range_Table.ObjPtr[pos]=cppBlockRange;
 
  if (spmd_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

};

/*
 * Class:     spmd_BlockRange
 * Method:    constructor
 * Signature: (ILspmd/Range;III)V
 */
JNIEXPORT void JNICALL Java_spmd_BlockRange_constructor__ILspmd_Range_2III
  (JNIEnv * env, jobject jthis, jint extent, jobject ker, jint layout, jint wlo, jint whi)
{

  BlockRange *cppBlockRange=new BlockRange((const)extent, spmd_Range_ResolvePtr(env,ker)->dim(), wlo, whi);

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Range_Table.ObjPtr[pos]);

//  spmd_Range_ObjPtr[pos]=cppBlockRange;
  spmd_Range_Table.ObjPtr[pos]=cppBlockRange;
 
  if (spmd_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

};

