/*
 * File         : spmd_CollapsedRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/29 19:48:08 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "spmd_CollapsedRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> spmd_Range_Table;

Range *spmd_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
CollapsedRange * spmd_CollapsedRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((CollapsedRange *)spmd_Range_ResolvePtr(env, jthis));
}


/*
 * Class:     spmd_CollapsedRange
 * Method:    constructor
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_spmd_CollapsedRange_constructor
  (JNIEnv * env, jobject jthis, jint extent)
{
  CollapsedRange *cppCollapsedRange=new CollapsedRange(extent);

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Range_Table.ObjPtr[pos]);

  spmd_Range_Table.ObjPtr[pos]=cppCollapsedRange;
  
  if (spmd_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
