/*
 * File         : spmd_CyclicRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/07/08 16:43:03 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "spmd_CyclicRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> spmd_Range_Table;

Range *spmd_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
CyclicRange * spmd_CyclicRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((CyclicRange *)spmd_Range_ResolvePtr(env, jthis));
}

//Layout int2emu(int); //defined in spmd_BlockRange.C

/*
 * Class:     spmd_CyclicRange
 * Method:    constructor
 * Signature: (Lspmd/Range;II)V
 */
// JNIEXPORT void JNICALL Java_spmd_CyclicRange_constructor__Lspmd_Range_2II
//   (JNIEnv *env, jobject jthis,jobject ker,jint numCycles,jint layout)
// {
//   CyclicRange *cppCyclicRange=new CyclicRange(*spmd_Range_ResolvePtr(env,ker),numCycles,int2emu(layout));

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (spmd_Range_Table.ObjPtr[pos]);

//   spmd_Range_Table.ObjPtr[pos]=cppCyclicRange;
  
//   if (spmd_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }

// };

/*
 * Class:     spmd_CyclicRange
 * Method:    constructor
 * Signature: (ILspmd/Range;I)V
 */
JNIEXPORT void JNICALL Java_spmd_CyclicRange_constructor__ILspmd_Range_2I
  (JNIEnv *env, jobject jthis,jint extent, jobject ker, jint layout)
{
  CyclicRange *cppCyclicRange=new CyclicRange(extent, spmd_Range_ResolvePtr(env,ker)->dim());

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Range_Table.ObjPtr[pos]);

  spmd_Range_Table.ObjPtr[pos]=cppCyclicRange;
  
  if (spmd_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
