/*
 * File         : spmd_DimRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/29 19:48:09 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "spmd_DimRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> spmd_Range_Table;

Range *spmd_Range_ResolvePtr(JNIEnv *, jobject);
Dimension * spmd_Dimension_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
DimRange * spmd_DimRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((DimRange *)spmd_Range_ResolvePtr(env, jthis));
}

/*
 * Class:     spmd_DimRange
 * Method:    constructor
 * Signature: (Lspmd/Dimension;)V
 */
JNIEXPORT void JNICALL Java_spmd_DimRange_constructor
  (JNIEnv *env, jobject jthis, jobject dim)
{
  DimRange *cppDimRange=new DimRange(*spmd_Dimension_ResolvePtr(env,dim));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (spmd_Range_Table.ObjPtr[pos]);

  spmd_Range_Table.ObjPtr[pos]=cppDimRange;
  
  if (spmd_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
