/*
 * File         : spmd_Dimension.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 13 12:03:03 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/01/30 17:53:23 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "spmd_Dimension.h"
#include "adlib.h"
#include "apgStack.h"

extern jfieldID hCPPObjID;

#include "jctable.h"
jctable<Dimension> spmd_Dimension_Table;

/*ResolvePtr
 */
Dimension * spmd_Dimension_ResolvePtr(JNIEnv *env, jobject jthis) {
  return(spmd_Dimension_Table.ObjPtr[env->GetIntField(jthis, hCPPObjID)]);
}

/*
 * Class:     spmd_Dimension
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("spmd/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
  jctable<Dimension> *tempspmd_Dimension_Table=new jctable<Dimension>;
  spmd_Dimension_Table=*tempspmd_Dimension_Table;
};

/*
 * Class:     spmd_Dimension
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_clean
  (JNIEnv *, jclass)
{
//  delete spmd_Dimension_ObjPtr;
//  delete spmd_Dimension_ObjRef;
};

/*
 * Class:     spmd_Dimension
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_constructor
  (JNIEnv * env, jobject jthis)
{
  Dimension *cppDim=new Dimension();
  long pos = spmd_Dimension_Table.NewHandle(cppDim);

  if (spmd_Dimension_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

//  spmd_Dimension_Table.IncRefCntr(pos);

  env->SetIntField(jthis, hCPPObjID, pos);
};

/*
 * Class:     spmd_Dimension
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_finalize
  (JNIEnv * env, jobject jthis)
{
  long thecppobj=env->GetIntField(jthis, hCPPObjID);
  long rc=spmd_Dimension_Table.DecRefCntr(thecppobj);
  if (rc==0) {
    delete spmd_Dimension_Table.ObjPtr[thecppobj];
    spmd_Dimension_Table.ObjPtr[thecppobj]=NULL;
  }
};


/*
 * Class:     spmd_Dimension
 * Method:    crd
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_spmd_Dimension_crd
  (JNIEnv * env, jobject jthis)
{
  int temp = spmd_Dimension_ResolvePtr(env, jthis)->crd();
  //printf("in crd dim address %x\n", spmd_Dimension_ResolvePtr(env, jthis));
  //printf("crd is %d\n", temp);
  return(temp);
};


/*
 * Class:     spmd_Dimension
 * Method:    over
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_over
  (JNIEnv * env, jobject jthis)
{
  apgStack.push(&apg) ;
  apg.restrict(*spmd_Dimension_ResolvePtr(env, jthis));
  //  spmd_Dimension_ResolvePtr(env, jthis)->where();
};

/*
 * Class:     spmd_Dimension
 * Method:    revo
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_spmd_Dimension_revo
  (JNIEnv * env, jobject jthis)
{
  apgStack.pop(&apg) ;
  //  spmd_Dimension_ResolvePtr(env, jthis)->erewh();
};
