/*
 * File         : hpjava_lang_BlockRange.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 13 12:06:49 1997
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:50 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_BlockRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Dimension> hpjava_lang_Dimension_Table;
extern jctable<Range> hpjava_lang_Range_Table;

Range *hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
BlockRange * hpjava_lang_BlockRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((BlockRange *)hpjava_lang_Range_ResolvePtr(env, jthis));
}

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
};

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_clean
  (JNIEnv *, jclass);

/*
  Layout int2emu(int i){
  switch (i) {
  case 0: 
    return (LAY_STANDARD);
    break;
  case 1: 
    return (LAY_PACKED);
    break;
  case 2: 
    return (LAY_ADAPT);
    break;
  case 3: 
    return (LAY_EXTENDED);
    break;
  default:
    break;
  }

  return(LAY_STANDARD);
}
*/

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;II)V
 */
// JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_constructor__Lhpjava_lang_Range_2II
//   (JNIEnv *env, jobject jthis,jobject ker,jint blockSize,jint layout)
// {
//   BlockRange *cppBlockRange=new BlockRange(*hpjava_lang_Range_ResolvePtr(env,ker),blockSize,int2emu(layout));

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (hpjava_lang_Range_Table.ObjPtr[pos]);

// //  hpjava_lang_Range_ObjPtr[pos]=cppBlockRange;
//   hpjava_lang_Range_Table.ObjPtr[pos]=cppBlockRange;
  
//   //printf("the range pointer is %x\n", cppBlockRange); //debug

//   if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }

// }

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;IIII)V
 */
// JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_constructor__Lhpjava_lang_Range_2IIII
//   (JNIEnv * env, jobject jthis, jobject ker, jint blockSize, jint layout, jint wlo, jint whi)
// {

//   BlockRange *cppBlockRange=new BlockRange(*hpjava_lang_Range_ResolvePtr(env,ker),blockSize,int2emu(layout),wlo,whi);

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (hpjava_lang_Range_Table.ObjPtr[pos]);

// //  hpjava_lang_Range_ObjPtr[pos]=cppBlockRange;
//   hpjava_lang_Range_Table.ObjPtr[pos]=cppBlockRange;
 
//   if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }
// };

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_constructor__ILhpjava_lang_Range_2I
  (JNIEnv * env, jobject jthis, jint extent, jobject ker, jint layout)
{

  BlockRange *cppBlockRange=new BlockRange(extent, hpjava_lang_Range_ResolvePtr(env,ker)->dim());

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Range_Table.ObjPtr[pos]);

//  hpjava_lang_Range_ObjPtr[pos]=cppBlockRange;
  hpjava_lang_Range_Table.ObjPtr[pos]=cppBlockRange;
 
  if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

};

/*
 * Class:     hpjava_lang_BlockRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;III)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_BlockRange_constructor__ILhpjava_lang_Range_2III
  (JNIEnv * env, jobject jthis, jint extent, jobject ker, jint layout, jint wlo, jint whi)
{

  BlockRange *cppBlockRange=new BlockRange((const)extent, hpjava_lang_Range_ResolvePtr(env,ker)->dim(), wlo, whi);

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Range_Table.ObjPtr[pos]);

//  hpjava_lang_Range_ObjPtr[pos]=cppBlockRange;
  hpjava_lang_Range_Table.ObjPtr[pos]=cppBlockRange;
 
  if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

};

