/*
 * File         : hpjava_lang_CollapsedRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:51 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_lang_CollapsedRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> hpjava_lang_Range_Table;

Range *hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
CollapsedRange * hpjava_lang_CollapsedRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((CollapsedRange *)hpjava_lang_Range_ResolvePtr(env, jthis));
}


/*
 * Class:     hpjava_lang_CollapsedRange
 * Method:    constructor
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_CollapsedRange_constructor
  (JNIEnv * env, jobject jthis, jint extent)
{
  CollapsedRange *cppCollapsedRange=new CollapsedRange(extent);

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Range_Table.ObjPtr[pos]);

  hpjava_lang_Range_Table.ObjPtr[pos]=cppCollapsedRange;
  
  if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
