/*
 * File         : hpjava_lang_CyclicRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:52 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_lang_CyclicRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> hpjava_lang_Range_Table;

Range *hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
CyclicRange * hpjava_lang_CyclicRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((CyclicRange *)hpjava_lang_Range_ResolvePtr(env, jthis));
}

//Layout int2emu(int); //defined in hpjava_lang_BlockRange.C

/*
 * Class:     hpjava_lang_CyclicRange
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;II)V
 */
// JNIEXPORT void JNICALL Java_hpjava_lang_CyclicRange_constructor__Lhpjava_lang_Range_2II
//   (JNIEnv *env, jobject jthis,jobject ker,jint numCycles,jint layout)
// {
//   CyclicRange *cppCyclicRange=new CyclicRange(*hpjava_lang_Range_ResolvePtr(env,ker),numCycles,int2emu(layout));

//   int pos = env->GetIntField(jthis, hCPPObjID);

//   delete (hpjava_lang_Range_Table.ObjPtr[pos]);

//   hpjava_lang_Range_Table.ObjPtr[pos]=cppCyclicRange;
  
//   if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
//     jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
//     env->ThrowNew(cError,"adlib memory allocation failed");
//     return;
//   }

// };

/*
 * Class:     hpjava_lang_CyclicRange
 * Method:    constructor
 * Signature: (ILhpjava/lang/Range;I)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_CyclicRange_constructor__ILhpjava_lang_Range_2I
  (JNIEnv *env, jobject jthis,jint extent, jobject ker, jint layout)
{
  CyclicRange *cppCyclicRange=new CyclicRange(extent, hpjava_lang_Range_ResolvePtr(env,ker)->dim());

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Range_Table.ObjPtr[pos]);

  hpjava_lang_Range_Table.ObjPtr[pos]=cppCyclicRange;
  
  if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
