/*
 * File         : hpjava_lang_DimRange.C
 * Author       : Guansong Zhang
 * Created      : Tue Jan 13 12:48:33 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:53 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_lang_DimRange.h"
#include "adlib.h"
#include "iostream.h"
#include "jctable.h"

extern jfieldID hCPPObjID;
extern jctable<Range> hpjava_lang_Range_Table;

Range *hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);
Dimension * hpjava_lang_Dimension_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
DimRange * hpjava_lang_DimRange_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((DimRange *)hpjava_lang_Range_ResolvePtr(env, jthis));
}

/*
 * Class:     hpjava_lang_DimRange
 * Method:    constructor
 * Signature: (Lhpjava/lang/Dimension;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_DimRange_constructor
  (JNIEnv *env, jobject jthis, jobject dim)
{
  DimRange *cppDimRange=new DimRange(*hpjava_lang_Dimension_ResolvePtr(env,dim));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Range_Table.ObjPtr[pos]);

  hpjava_lang_Range_Table.ObjPtr[pos]=cppDimRange;
  
  if (hpjava_lang_Range_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
}
