/*
 * File         : hpjava_lang_Group.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 20 09:45:42 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/03/19 17:56:40 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_Group.h"
#include "adlib.h"
#include "apgStack.h"

extern jfieldID hCPPObjID;

Procs * hpjava_lang_Procs_ResolvePtr(JNIEnv *, jobject);
Location * hpjava_lang_Location_ResolvePtr(JNIEnv *, jobject);

#include "jctable.h"
jctable<Group> hpjava_lang_Group_Table;

/*ResolvePtr
 */
Group * hpjava_lang_Group_ResolvePtr(JNIEnv *env, jobject jthis) {
  return(hpjava_lang_Group_Table.ObjPtr[env->GetIntField(jthis, hCPPObjID)]);
}

/*
 * Class:     hpjava_lang_Group
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");
  jctable<Group> *temphpjava_lang_Group_Table=new jctable<Group>;
  hpjava_lang_Group_Table=*temphpjava_lang_Group_Table;
  delete temphpjava_lang_Group_Table;
};

/*
 * Class:     hpjava_lang_Group
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_clean
  (JNIEnv *, jclass)
{
//  delete hpjava_lang_Group_ObjPtr;
//  delete hpjava_lang_Group_ObjRef;
};

/*
 * Class:     hpjava_lang_Group
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_constructor
  (JNIEnv *env, jobject jthis)
{
  Group *cppGroup=new Group();
  long pos=hpjava_lang_Group_Table.NewHandle(cppGroup);

  if (hpjava_lang_Group_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  // hpjava_lang_Group_IncRefCntr(pos);
  
  env->SetIntField(jthis, hCPPObjID, pos);
};

/*
 * Class:     hpjava_lang_Group
 * Method:    copy
 * Signature: (Lhpjava/lang/Group;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_copy
  (JNIEnv * env, jobject jthis, jobject jsrc) 
{
  Group * cppGroup=hpjava_lang_Group_ResolvePtr(env, jthis); 
  Group * csrc=hpjava_lang_Group_ResolvePtr(env, jsrc); 

  *cppGroup = *csrc;

}

/*
 * Class:     hpjava_lang_Group
 * Method:    constructor
 * Signature: (Lhpjava/lang/Procs;)V
 */
/*
JNIEXPORT void JNICALL Java_hpjava_lang_Group_constructor__Lhpjava_lang_Procs_2
  (JNIEnv *env, jobject jthis,jobject p)
{
  Group *cppGroup=new Group(*hpjava_lang_Procs_ResolvePtr(env,p));
  long pos=hpjava_lang_Group_Table.Newhandle(cppGroup);

  if (hpjava_lang_Group_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

 // hpjava_lang_Group_IncRefCntr(pos);
 
  env->SetIntField(jthis, hCPPObjID, pos);
};
*/

/*
 * Class:     hpjava_lang_Group
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_finalize
  (JNIEnv * env, jobject jthis)
{
  int thecppobj=env->GetIntField(jthis, hCPPObjID);
  int rc=hpjava_lang_Group_Table.DecRefCntr(thecppobj);
  if (rc==0) {
    delete hpjava_lang_Group_Table.ObjPtr[thecppobj];
    hpjava_lang_Group_Table.ObjPtr[thecppobj]=NULL;
  }

};

/*
 * Class:     hpjava_lang_Group
 * Method:    on
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_hpjava_lang_Group_on
  (JNIEnv * env, jobject jthis)
{
  Group * cppGroup=hpjava_lang_Group_ResolvePtr(env, jthis); 

  apgStack.push(&apg);
  apg = *cppGroup;

  int temp = cppGroup->member();
  //printf("testing on: %d\n", temp); // debug
  
  if (temp)
    return (JNI_TRUE);
  else
    return (JNI_FALSE);

  //  return(JNI_TRUE);
};

/*
 * Class:     hpjava_lang_Group
 * Method:    no
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_no
  (JNIEnv * env, jobject jthis)
{  
  apgStack.pop(&apg);
};


/*
 * Class:     hpjava_lang_Group
 * Method:    id
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Group_id
  (JNIEnv * env, jobject jthis)
{
  return (hpjava_lang_Group_ResolvePtr(env, jthis))->id();
}

/*
 * Class:     hpjava_lang_Group
 * Method:    divide
 * Signature: (Lhpjava/lang/Location;)Lhpjava/lang/Group;
 */
JNIEXPORT jobject JNICALL Java_hpjava_lang_Group_divide
  (JNIEnv *env, jobject jthis, jobject i)
{
  //Group *newCPPgroupPtr=new Group();

  Group CPPgroup = (*hpjava_lang_Group_ResolvePtr(env, jthis))/(*hpjava_lang_Location_ResolvePtr(env,i));

  //*newCPPgroupPtr=CPPgroup;

  //long pos=hpjava_lang_Group_NewHandle(newCPPgroupPtr);

  jclass ccGroup=NULL;
  ccGroup=env->FindClass("hpjava/lang/Group");
  if (env->ExceptionOccurred()) return 0;
  jmethodID handleConstructorID = env->GetMethodID(ccGroup, "<init>", "()V");
  jobject jNode=env->NewObject(ccGroup, handleConstructorID);

  Group *newCPPgroupPtr=hpjava_lang_Group_ResolvePtr(env,jNode);

  *newCPPgroupPtr=CPPgroup;
  return(jNode);
}

/*
 * Class:     hpjava_lang_Group
 * Method:    restrict
 * Signature: (Lhpjava/lang/Location;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_restrict
  (JNIEnv * env , jobject jthis, jobject i)
{
  (*hpjava_lang_Group_ResolvePtr(env, jthis))/=(*hpjava_lang_Location_ResolvePtr(env,i));
};

/*
 * Class:     hpjava_lang_Group
 * Method:    show
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Group_show
  (JNIEnv * env, jobject jthis, jstring message)
{
  int length=env->GetStringUTFLength(message);

  char * cmessage=new char[length+1];

  const char * jmessagePtr=env->GetStringUTFChars(message, 0);

  for (int i=0; i<length; i++)
    cmessage[i]=*(jmessagePtr+i);
  cmessage[length]='\0';

  env->ReleaseStringUTFChars(message, jmessagePtr);

  int pos =  env->GetIntField(jthis, hCPPObjID);

  AdlibPrintf("Group %s, Handle %d, Address %x\n", cmessage, pos, hpjava_lang_Group_ResolvePtr(env, jthis));

  hpjava_lang_Group_ResolvePtr(env, jthis)->show();

  delete [] cmessage;

};

