/*
 * File         : hpjava_lang_Index.C
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 10:05:03 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:55 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_lang_Index.h"

#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;
#include "jctable.h"

extern jctable<Location> hpjava_lang_Location_Table;

Location * hpjava_lang_Location_ResolvePtr(JNIEnv *, jobject);
Range * hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
Index * hpjava_lang_Index_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((Index *)hpjava_lang_Location_ResolvePtr(env, jthis));
}

/*
 * Class:     hpjava_lang_Index
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Index_constructor
  (JNIEnv * env, jobject jthis, jobject jRange)
{
  Index * cppIndex = new Index(*hpjava_lang_Range_ResolvePtr(env, jRange));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Location_Table.ObjPtr[pos]);
  
  hpjava_lang_Location_Table.ObjPtr[pos]=cppIndex;

  if (hpjava_lang_Location_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
  
};

/*
 * Class:     hpjava_lang_Index
 * Method:    begin
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Index_begin
  (JNIEnv * env, jobject jthis)
{
  hpjava_lang_Index_ResolvePtr(env, jthis)->begin();
};

/*
 * Class:     hpjava_lang_Index
 * Method:    next
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Index_next
  (JNIEnv * env, jobject jthis)
{
  hpjava_lang_Index_ResolvePtr(env, jthis)->next();
};

/*
 * Class:     hpjava_lang_Index
 * Method:    idx
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Index_idx
  (JNIEnv * env, jobject jthis)
{
  //  return (int)(*hpjava_lang_Index_ResolvePtr(env, jthis));
  return printf("function canceled.\n");
};

/*
 * Class:     hpjava_lang_Index
 * Method:    shift
 * Signature: (I)Lhpjava/lang/Location;
 */
JNIEXPORT jobject JNICALL Java_hpjava_lang_Index_shift
  (JNIEnv * env, jobject jthis, jint amount)
{
  Location location;

  if (amount>=0)
    location = (*hpjava_lang_Index_ResolvePtr(env, jthis)>>amount);
  else
    location = (*hpjava_lang_Index_ResolvePtr(env, jthis)<<(-amount));
      
  jclass ccLocation=NULL;
  ccLocation=env->FindClass("hpjava/lang/Location");
  if (env->ExceptionOccurred()) return 0;
  jmethodID handleConstructorID = env->GetMethodID(ccLocation, "<init>", "()V");
  jobject jNode=env->NewObject(ccLocation, handleConstructorID);

  Location *newLocationPtr=hpjava_lang_Location_ResolvePtr(env,jNode);

  *newLocationPtr=location;

  return(jNode);
};
