/*
 * File         : hpjava_lang_LocBlocksIndex.C
 * Author       : Guansong Zhang
 * Created      : Wed Jan  7 14:42:39 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/09/30 19:46:57 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "hpjava_lang_LocBlocksIndex.h"

#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

jfieldID countID=0;
jfieldID loopingID=0;

#include "jctable.h"

extern jctable<Location> hpjava_lang_Location_Table;

Location * hpjava_lang_Location_ResolvePtr(JNIEnv *, jobject);
Range * hpjava_lang_Range_ResolvePtr(JNIEnv *, jobject);

/*ResolvePtr
 */
LocBlocksIndex * hpjava_lang_LocBlocksIndex_ResolvePtr(JNIEnv *env, jobject jthis) {
  return((LocBlocksIndex *)hpjava_lang_Location_ResolvePtr(env, jthis));
}

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_LocBlocksIndex_init
  (JNIEnv * env , jclass jthis)
{
  jclass LocBlocksIndex_class=env->FindClass("hpjava/lang/LocBlocksIndex");
  countID=env->GetFieldID(LocBlocksIndex_class, "count", "I");
  loopingID=env->GetFieldID(LocBlocksIndex_class, "looping", "I");
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    constructor
 * Signature: (Lhpjava/lang/Range;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_LocBlocksIndex_constructor
  (JNIEnv * env, jobject jthis, jobject jRange)
{
  LocBlocksIndex * cppLocBlocksIndex = new LocBlocksIndex(*hpjava_lang_Range_ResolvePtr(env, jRange));

  int pos = env->GetIntField(jthis, hCPPObjID);

  delete (hpjava_lang_Location_Table.ObjPtr[pos]);
  
  hpjava_lang_Location_Table.ObjPtr[pos]=cppLocBlocksIndex;

  if (hpjava_lang_Location_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }
  
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    beginLocBlk
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_LocBlocksIndex_beginLocBlk
  (JNIEnv * env, jobject jthis)
{
  hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->beginLocBlk();
};


/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    test
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_hpjava_lang_LocBlocksIndex_test
  (JNIEnv * env, jobject jthis)
{
  if (hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->test())
    return (JNI_TRUE);
  else
    return (JNI_FALSE);
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    nextLocBlk
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_LocBlocksIndex_nextLocBlk
  (JNIEnv * env, jobject jthis)
{
  hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->nextLocBlk();
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    count
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_LocBlocksIndex_count
  (JNIEnv * env, jobject jthis)
{
  return (hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->count);
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    glb_bas
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_LocBlocksIndex_glb_1bas
  (JNIEnv * env, jobject jthis)
{
  return (hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->glb_bas);
};

/*
 * Class:     hpjava_lang_LocBlocksIndex
 * Method:    glb_stp
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_LocBlocksIndex_glb_1stp
  (JNIEnv * env, jobject jthis)
{
  return (hpjava_lang_LocBlocksIndex_ResolvePtr(env, jthis)->glb_stp);
};
