/*
 * File         : hpjava_lang_Stride.C
 * Author       : Guansong Zhang
 * Created      : Mon Oct 13 12:06:49 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1999/03/19 17:56:44 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

#include "hpjava_lang_Stride.h"
#include "adlib.h"
#include "iostream.h"

extern jfieldID hCPPObjID;

jfieldID offsetID=0;
jfieldID stepID=0;
jfieldID lenID=0;

Location * hpjava_lang_Location_ResolvePtr(JNIEnv *, jobject);
LocBlocksIndex * hpjava_lang_LocBlocksIndex_ResolvePtr(JNIEnv *, jobject);

#include "jctable.h"
jctable<Stride> hpjava_lang_Stride_Table;

/*ResolvePtr
 */
Stride * hpjava_lang_Stride_ResolvePtr(JNIEnv *env, jobject jthis) {
  return(hpjava_lang_Stride_Table.ObjPtr[env->GetIntField(jthis, hCPPObjID)]);
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    init
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_init
  (JNIEnv * env, jclass thisClass)
{
  jclass InterfaceObject_class=env->FindClass("hpjava/lang/InterfaceObject");
  hCPPObjID=env->GetFieldID(InterfaceObject_class, "hCPPObj", "I");

  jclass Stride_class=env->FindClass("hpjava/lang/Stride");
  offsetID=env->GetFieldID(Stride_class, "offset", "I");
  stepID=env->GetFieldID(Stride_class, "step", "I");
  lenID=env->GetFieldID(Stride_class, "len", "I");

  jctable<Stride> *temphpjava_lang_Stride_Table=new jctable<Stride>;
  hpjava_lang_Stride_Table=*temphpjava_lang_Stride_Table;
  delete temphpjava_lang_Stride_Table;
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    clean
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_clean
  (JNIEnv *, jclass);

/*
 * Class:     hpjava_lang_Stride
 * Method:    constructor
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_constructor__
  (JNIEnv *env, jobject jthis)
{
  Stride *cppStride=new Stride();
  long pos=  hpjava_lang_Stride_Table.NewHandle(cppStride);

  //printf("Stride: %d\n",pos);

  if (hpjava_lang_Stride_Table.ObjPtr[pos]==NULL) {
    jclass cError=env->FindClass("java/lang/OutOfMemeoryError");
    env->ThrowNew(cError,"adlib memory allocation failed");
    return;
  }

  //hpjava_lang_Stride_IncRefCntr(pos);
  
  env->SetIntField(jthis, hCPPObjID, pos);

}

/*
 * Class:     hpjava_lang_Stride
 * Method:    constructor
 * Signature: (Lhpjava/lang/Stride;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_constructor__Lhpjava_lang_Stride_2
  (JNIEnv *, jobject, jobject);


/*
 * Class:     hpjava_lang_Stride
 * Method:    finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_finalize
  (JNIEnv * env, jobject jthis)
{
  long thecppobj=env->GetIntField(jthis, hCPPObjID);
  long rc=hpjava_lang_Stride_Table.DecRefCntr(thecppobj);
  if (rc==0) {
    delete hpjava_lang_Stride_Table.ObjPtr[thecppobj];
    hpjava_lang_Stride_Table.ObjPtr[thecppobj]=NULL;
  }
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    len
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_len
  (JNIEnv *env, jobject jthis)
{
  return(hpjava_lang_Stride_ResolvePtr(env, jthis)->len());
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    disp
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_disp
  (JNIEnv * env, jobject jthis, jint sub)
{
  return(hpjava_lang_Stride_ResolvePtr(env, jthis)->disp(sub));
};


/*
 * Class:     hpjava_lang_Stride
 * Method:    disp_step
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_disp_1step
  (JNIEnv * env, jobject jthis, jint sub_stp)
{
  //  return(hpjava_lang_Stride_ResolvePtr(env, jthis)->disp_step(sub_stp));
  return printf("this function is canceled.\n");
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    offset
 * Signature: (Lhpjava/lang/Location;)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_offset
  (JNIEnv *env, jobject jthis, jobject i)
{
  return(hpjava_lang_Stride_ResolvePtr(env, jthis)->offset(*hpjava_lang_Location_ResolvePtr(env,i)));
}

/*
 * Class:     hpjava_lang_Stride
 * Method:    step
 * Signature: (Lhpjava/lang/Location;)I
 */
JNIEXPORT jint JNICALL Java_hpjava_lang_Stride_step
  (JNIEnv * env, jobject jthis, jobject i)
{
  return(hpjava_lang_Stride_ResolvePtr(env, jthis)->step(hpjava_lang_LocBlocksIndex_ResolvePtr(env,i)->sub_stp));
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    updateLocBlk
 * Signature: (Lhpjava/lang/LocBlocksIndex;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_updateLocBlk
  (JNIEnv * env, jobject jthis, jobject jLocBlocksIndex)
{
  LocBlocksIndex * i = hpjava_lang_LocBlocksIndex_ResolvePtr(env,jLocBlocksIndex);
  Stride * std = hpjava_lang_Stride_ResolvePtr(env, jthis);

  int offset = std->offset(*i);
  int step = std->step(i->sub_stp);
  int len = std->len();

  env->SetIntField(jthis, offsetID, offset);
  env->SetIntField(jthis, stepID, step);
  env->SetIntField(jthis, lenID, len);
};

/*
 * Class:     hpjava_lang_Stride
 * Method:    show
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_hpjava_lang_Stride_show
  (JNIEnv * env, jobject jthis, jstring message)
{
  jclass Stride_class=env->FindClass("hpjava/lang/Stride");
  jfieldID sizeID=env->GetFieldID(Stride_class, "size", "I");;

  int size=env->GetIntField(jthis, sizeID);

  int length=env->GetStringUTFLength(message);

  char * cmessage=new char[length+1];

  const char * jmessagePtr=env->GetStringUTFChars(message, 0);

  for (int i=0; i<length; i++)
    cmessage[i]=*(jmessagePtr+i);
  cmessage[length]='\0';

  env->ReleaseStringUTFChars(message, jmessagePtr);

  int pos =  env->GetIntField(jthis, hCPPObjID);

  AdlibPrintf("Stride %s, Handle %d, Address %x, Size %d\n", cmessage, pos, hpjava_lang_Stride_ResolvePtr(env, jthis), size);

  delete [] cmessage;

};
