package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Adlib extends InterfaceObject {

  static public native void _Initialize(String[] args);
  static public native void _Finalize();
  static public native void _InitInterFace();  
  static public native void _InitAPG(Group apg);

  static public void remap(SectionI dst, SectionI src) {

    //dst.dad.show("dst"); //debug
    //src.dad.show("src"); //debug

    Remap schedule=new Remap(dst, src);
    schedule.execute();
  };

  static public void remap(SectionF dst, SectionF src) {

    //dst.dad.show("dst"); //debug
    //src.dad.show("src"); //debug

    Remap schedule=new Remap(dst, src);
    schedule.execute();
  };
  
  static public void shift(SectionI dst, SectionI src, int shift, int dim, int mode) {
    Shift schedule=new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void shift(SectionF dst, SectionF src, int shift, int dim, int mode) {
    Shift schedule=new Shift(dst, src, shift, dim, mode);
    schedule.execute();
  };

  static public void copy(SectionI dst, SectionI src) {
    // This is temporaryly implemented as remap;

    Remap schedule=new Remap(dst, src);
    schedule.execute();
  };

  static public void copy(SectionF dst, SectionF src) {
    // This is temporaryly implemented as remap;

    Remap schedule=new Remap(dst, src);
    schedule.execute();
  };

  static public void writeHalo(SectionI src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule=new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionF src, int[] wlo, int[] whi, int[] mode) {
    WriteHalo schedule=new WriteHalo(src, wlo, whi, mode);
    schedule.execute();
  };

  static public void writeHalo(SectionI src, int[] wlo, int[] whi) {
    WriteHalo schedule=new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public void writeHalo(SectionF src, int[] wlo, int[] whi) {
    WriteHalo schedule=new WriteHalo(src, wlo, whi);
    schedule.execute();
  };

  static public native void _aprintf(String control, 
				     DAD dad, int type, Object ref, int ost);

  static public void aprintf(String control, Section arg) {
    if (arg instanceof SectionI) {
      _aprintf(control, arg.dad(), TypeConstants.INT, arg.ref(), arg.off());
    }
    else if (arg instanceof SectionF) {
      _aprintf(control, arg.dad(), TypeConstants.FLOAT, arg.ref(), arg.off());
    }
    else
      throw new Error();
  };

  //using java buffer is different from C buffer
  //so a native method is added.

  static private native void printString(String s);

  static public void rprint(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"");
    } root.no();
  }

  static public void rprintln(String x) {
    Procs0 root = new Procs0();
    if (root.on()) {
      printString(x+"\n");
    } root.no();
  }
  
//   static public void Initialize(String[] args) {
//     Spmd.Initialize(args);
//   };

//   static public void Finalize() {
//     Spmd.Finalize();
//   };
  
//   static public Group apg;
//   static public Group global;
//   static public Group root;

}
