/*
 * File         : Shift.java
 * Author       : Guansong Zhang
 * Created      : Tue Nov  4 20:40:55 1997
 * Revision     : $Revision: 1.2 $
 * Updated      : $Date: 1998/10/27 16:21:32 $
 */

package hpjava.spmd.adlib;

import hpjava.lang.*;
import hpjava.spmd.*;

public class Shift extends InterfaceObject {
  
  private static native void init();
  public static native void clean();

  private native void constructor(DAD dst, DAD src, int len, int shift, int dim, int mode); 

  /*
  public Shift(DAD dst, DAD src, int _type, int shift, int dim, int mode) {
    int len;

    type=_type;
    
    switch (type) {
    case 4:
    case 6: 
      len=4;
      constructor(dst, src, len, shift, dim, mode);
      break;
    default:
      System.out.println("not finished");

    };
  };

  */

  public Shift(SectionI dst, SectionI src, int shift, int dim, int mode) {
    type=TypeConstants.INT;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.INTSIZE, shift, dim, mode);
  }

  public Shift(SectionF dst, SectionF src, int shift, int dim, int mode) {
    type=TypeConstants.FLOAT;

    sref=src.dat();
    soff=src.off();
    
    dref=dst.dat();
    doff=dst.off();
   
    constructor(dst.dad(), src.dad(), TypeConstants.FLOATSIZE, shift, dim, mode);
  }

  public native void finalize();


  private native void execute(int[] dst, long dOffset, int[] src, long sOffset);
  private native void execute(float[] dst, long dOffset, float[] src, long sOffset);
   
  public void execute() {
    
    switch (this.type) {

    case TypeConstants.INT: {
      execute((int[])dref, doff, (int[])sref, soff); 
      break;
    }

    case TypeConstants.FLOAT: {
      execute((float[])dref, doff, (float[])sref, soff); 
      break;
    }

    default:
      System.out.println("not finished");
      break;
    }

  };

  private int type;
  private Object sref, dref;
  private int soff, doff;

  static {
    init();
  }

}
