
// Operations on collapsed ranges.


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CollapsedRangeRep': collapsed template range.                //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class CollapsedRangeRep : public RangeRep {
public :
  CollapsedRangeRep(const int _extent) :
      RangeRep(_extent, 0, 1, Dimension(), DIST_COLLAPSED) {}

  RangeRep* ker() const ;

  RangeRep* shell() const ;

  void location(Location* loc, const int glb) const ;

  void block(Block* blk, const int ker_glb) const ;
  void block2(Block* blk, const int ker_glb,
              const int count, const int base) const ;
  void block3(Block* blk, const int ker_glb,
              const int count, const int base, const int stride) const ;

  void crds(int* ker_count, int* ker_bas, int* ker_str) const ;
  void crds2(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base) const ;
  void crds3(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base, const int stride) const ;

  int volume() const ;

  int isAligned(RangeRep* x) const ;

  void show() ;

protected:
  int parSize ;

MEMORY_POOL_DECS
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `ExtendedCollapsedRangeRep': Collapsed range of array with    //
//                                    ghost areas.                     //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class ExtendedCollapsedRangeRep : public CollapsedRangeRep {
public :
  ExtendedCollapsedRangeRep(const int _extent,
                            const int _wlo, const int _whi) :
          CollapsedRangeRep(_extent), wlo(_wlo), whi(_whi) {}

  int disp(const int sub) const ;

  int volume() const ;

protected :
  int wlo, whi ;
 
MEMORY_POOL_DECS
} ;

// -------------------------------------------------------------
// Things to do
//

