
// Operations on cyclic distributed ranges.


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `CyclicRangeRep': Cyclic-distributed template range.          //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class CyclicRangeRep : public RangeRep {
public :
  CyclicRangeRep(const int _extent, RangeRep* _kernel, const int _numLayers) :
          RangeRep(_extent, _kernel, _kernel->lev() + 1, _kernel->dim(),
                   DIST_CYCLIC),
          numLayers(_numLayers), numProcs(_kernel->size()) {
    kernel->incr() ;
  }

  ~CyclicRangeRep() {
    kernel->decr() ;
  }

  RangeRep* shell() const ;

  void location(Location* loc, const int glb) const ;

  void block(Block* blk, const int ker_glb) const ;
  void block2(Block* blk, const int ker_glb,
              const int count, const int base) const ;
  void block3(Block* blk, const int ker_glb,
              const int count, const int base, const int stride) const ;

  void crds2(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base) const ;
  void crds3(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base, const int stride) const ;

  int volume() const ;

  int glb(const int sub, const int ker_glb) const ;

  int isAligned(RangeRep* x) const ;

  void show() ;

protected :
  int numLayers, numProcs ;

MEMORY_POOL_DECS
} ;


// -------------------------------------------------------------
// Things to do
//

