
// Operations on stepped block distributed ranges.

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `StepRangeRep': stepped block-distributed template range.     //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class StepRangeRep : public RangeRep {
public :
  StepRangeRep(RangeRep* _kernel, const int _blockSize, const int _stepCrd) :
          RangeRep(_blockSize * _kernel->size() + _stepCrd,
                   _kernel, _kernel->lev() + 1, _kernel->dim(), DIST_STEP),
          blockSize(_blockSize), stepCrd(_stepCrd),
          stepSub(_stepCrd * (_blockSize + 1)) {
    kernel->incr() ;
  }

  ~StepRangeRep() {
    kernel->decr() ;
  }

  RangeRep* shell() const ;

  void location(Location* loc, const int glb) const ;

  void block(Block* blk, const int ker_glb) const ;
  void block2(Block* blk, const int ker_glb,
              const int count, const int base) const ;
  void block3(Block* blk, const int ker_glb,
              const int count, const int base, const int stride) const ;

  void crds2(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base) const ;
  void crds3(int* ker_count, int* ker_bas, int* ker_str,
             const int count, const int base, const int stride) const ;

  int volume() const ;

  int glb(const int sub, const int ker_glb) const ;

  int isAligned(RangeRep* x) const ;

  void show() ;

protected :

  int to_ker_glb(const int tem) const {
    if(tem < stepSub)
      return tem / (blockSize + 1) ;
    else
      return (tem - stepCrd) / blockSize ;
  }

  int blockSize, stepCrd, stepSub ;

MEMORY_POOL_DECS
} ;


// -------------------------------------------------------------
// Things to do
//

