
      INTEGER pcrc_integer, pcrc_real, pcrc_double, pcrc_character,     &
     &        pcrc_complex, pcrc_logical

      PARAMETER(pcrc_integer   = 1,                                     &
     &          pcrc_real      = 2,                                     &
     &          pcrc_double    = 3,                                     &
     &          pcrc_character = 4,                                     &
     &          pcrc_complex   = 5,                                     &
     &          pcrc_logical   = 6)

      INTEGER pcrc_size_integer, pcrc_size_real, pcrc_size_double,      &
     &        pcrc_size_complex, pcrc_size_logical

      PARAMETER(pcrc_size_integer   = 4,                                &
     &          pcrc_size_real      = 4,                                &
     &          pcrc_size_double    = 8,                                &
     &          pcrc_size_complex   = 8,                                &
     &          pcrc_size_logical   = 4)

      INTEGER pcrc_block, pcrc_cyclic

      PARAMETER(pcrc_block = 1, pcrc_cyclic = 2)

      INTEGER pcrc_group_glob, pcrc_group_root

      PARAMETER(pcrc_group_glob = 1,                                    &
     &          pcrc_group_root = 2)

      INTERFACE
        SUBROUTINE pcrc_init()
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_finalize()
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_new_group_grid(rank, shape)
          INTEGER rank
          INTEGER shape(rank)
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_delete_group(grp)
          INTEGER grp
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_new_range_distribute(g_lb, g_ub,          &
     &                                             distribution,        &
     &                                             grp_grid, dim)
          INTEGER g_lb, g_ub
          INTEGER grp_grid
          INTEGER dim
          INTEGER distribution
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_collapse(g_lb, g_ub)
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_align(g_lb, g_ub,               &
     &                                    offset, stride, rng_parent)
          INTEGER rng_parent
          INTEGER offset, stride
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_copy(rng_parent)
          INTEGER rng_parent
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_new_range_loop(g_lb, g_ub, g_stride,      &
     &                                   offset, stride, rng_parent)
          INTEGER rng_parent
          INTEGER g_lb, g_ub, g_stride
          INTEGER offset, stride
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_delete_range(rng)
          INTEGER rng
        END
      END INTERFACE


!     INTERFACE
!       INTEGER FUNCTION pcrc_new_array_data(data,                       &
!    &                                       element_type, element_size, &
!    &                                       rank, majority, grp)
!         choice  data(...)
!         INTEGER element_type
!         INTEGER element_size
!         INTEGER rank
!         INTEGER majority
!         INTEGER grp
!       END
!     END INTERFACE

      INTEGER pcrc_new_array_data

      INTERFACE
        SUBROUTINE pcrc_set_array_distribute(dad, dim, g_lb, g_ub,      &
     &                                       distribution,              &
     &                                       grp_grid, dim_grid)
          INTEGER dad
          INTEGER dim, dim_grid
          INTEGER g_lb, g_ub
          INTEGER grp_grid
          INTEGER distribution
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_collapse(dad, dim, g_lb, g_ub)
          INTEGER dad
          INTEGER dim
          INTEGER g_lb, g_ub
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_align(dad, dim, g_lb, g_ub,           &
     &                                  offset, stride, rng_parent)
          INTEGER dad
          INTEGER dim
          INTEGER g_lb, g_ub
          INTEGER offset, stride
          INTEGER rng_parent
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_copy(dad, dim, rng_parent)
          INTEGER dad
          INTEGER dim
          INTEGER rng_parent
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_new_array_section(rank, dad_parent)
          INTEGER rank
          INTEGER dad_parent
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_triplet(dad, dim,
     &                                    lb, ub, stride,               &
     &                                    dad_parent, dim_parent)
          INTEGER dad, dad_parent
          INTEGER dim, dim_parent
          INTEGER lb, ub, stride
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_set_array_scalar(dad, i, dad_parent, dim_parent)
          INTEGER dad, dad_parent
          INTEGER dim_parent
          INTEGER i
        END
      END INTERFACE


!     INTERFACE
!       INTEGER FUNCTION pcrc_new_array_copy(data, dad_parent)
!         choice  data(...)
!         INTEGER dad_parent
!       END
!     END INTERFACE

      INTEGER pcrc_new_array_copy


      INTERFACE
        SUBROUTINE pcrc_delete_array(dad)
          INTEGER dad
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_grp(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_rng(dad, dim)
          INTEGER dad
          INTEGER dim
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_size(dad)
          INTEGER dad
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_str(dad, dim)
          INTEGER dad
          INTEGER dim
        END
      END INTERFACE


      INTERFACE
        LOGICAL FUNCTION pcrc_on(grp)
          INTEGER grp
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_reset_array_bounds(dad, dim,                    &
     &      lb, ub, stride, lb_parent, ub_parent, stride_parent)
          INTEGER dad
          INTEGER dim
          INTEGER lb, ub, stride, lb_parent, ub_parent, stride_parent
        END
      END INTERFACE

!      INTERFACE
!        SUBROUTINE pcrc_reset_array_base(dad, data)
!          INTEGER dad
!          choice data(...)
!        END
!      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_glob(rng, l_i)
          INTEGER rng
          INTEGER l_i
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_loc(rng, g_i)
          INTEGER rng
          INTEGER g_i
        END
      END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_loop_bounds(rng, l_lb, l_ub, l_stride)
          INTEGER rng
          INTEGER l_lb, l_ub, l_stride
        END
      END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_shift(dad, dad_source, dim, amount)
          INTEGER dad, dad_source
          INTEGER dim, amount
        END
      END INTERFACE

!     INTERFACE
!       SUBROUTINE pcrc_tshift(data, dad_source, dim, amount)
!         choice  data(...)
!         INTEGER dad_source
!         INTEGER dim, amount
!       END
!     END INTERFACE


      INTERFACE
        SUBROUTINE pcrc_remap(dad, dad_source)
          INTEGER dad, dad_source
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_detect_communication(dad, dad_source,     &
     &                                         dim, l, u, stride, a, b, &
     &                                         m, c, status)
          INTEGER dad, dad_source
          INTEGER dim
          INTEGER l, u, stride
          INTEGER a, b
          REAL m, c
          INTEGER status
        END
      END INTERFACE


      INTERFACE
        INTEGER FUNCTION pcrc_integer_alloc(size)
          INTEGER size
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_integer_free(base)
          INTEGER base
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_real_alloc(size)
          INTEGER size
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_real_free(base)
          INTEGER base
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_double_alloc(size)
          INTEGER size
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_double_free(base)
          INTEGER base
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_complex_alloc(size)
          INTEGER size
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_complex_free(base)
          INTEGER base
        END
      END INTERFACE

      INTERFACE
        INTEGER FUNCTION pcrc_logical_alloc(size)
          INTEGER size
        END
      END INTERFACE

      INTERFACE
        SUBROUTINE pcrc_logical_free(base)
          INTEGER base
        END
      END INTERFACE


      INCLUDE 'pcrc_stack.inc'

!2345678901234567890123456789012345678901234567890123456789012345678901234567890
!    &                                                                  &
