
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !
!                                                                     !
!  Stack management.                                                  !
!                                                                     !
! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - !

      INTEGER FUNCTION pcrc_integer_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_integer_alloc = base
      END
        
      SUBROUTINE pcrc_integer_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END

      INTEGER FUNCTION pcrc_real_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_real_alloc = base
      END
        
      SUBROUTINE pcrc_real_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END

      INTEGER FUNCTION pcrc_double_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

!       Complications because must be double-word aligned.

        INTEGER object_size
        PARAMETER(object_size = 2)

        base = pcrc_stack_ptr / object_size + 1
        pcrc_stack(object_size * base - 1) = pcrc_stack_ptr
        pcrc_stack_ptr = object_size * (base + size)
        CALL pcrc_check_stack()

        pcrc_double_alloc = base
      END
        
      SUBROUTINE pcrc_double_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        INTEGER object_size
        PARAMETER(object_size = 2)

        pcrc_stack_ptr = pcrc_stack(object_size * base - 1)
      END

      INTEGER FUNCTION pcrc_complex_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

!       Complications because must be double-word aligned.

        INTEGER object_size
        PARAMETER(object_size = 2)

        base = pcrc_stack_ptr / object_size + 1
        pcrc_stack(object_size * base - 1) = pcrc_stack_ptr
        pcrc_stack_ptr = object_size * (base + size)
        CALL pcrc_check_stack()

        pcrc_complex_alloc = base
      END
        
      SUBROUTINE pcrc_complex_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        INTEGER object_size
        PARAMETER(object_size = 2)

        pcrc_stack_ptr = pcrc_stack(object_size * base - 1)
      END

      INTEGER FUNCTION pcrc_logical_alloc(size)
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        INTEGER base

        base = pcrc_stack_ptr
        pcrc_stack_ptr = base + size
        CALL pcrc_check_stack()

        pcrc_logical_alloc = base
      END
        
      SUBROUTINE pcrc_logical_free(base)
        IMPLICIT NONE
        INTEGER base

        INCLUDE 'pcrc_stack.inc'

        pcrc_stack_ptr = base
      END


      SUBROUTINE pcrc_check_stack()
        IMPLICIT NONE
        INTEGER size

        INCLUDE 'pcrc_stack.inc'

        IF(pcrc_stack_ptr .GT. pcrc_stack_size) THEN
          STOP '*** PCRC runtime error.  Stack exhausted. ***'
        ENDIF
      END


      BLOCK DATA
        IMPLICIT NONE
        INCLUDE 'pcrc_stack.inc'
        
        DATA pcrc_stack_ptr /0/
      END


!2345678901234567890123456789012345678901234567890123456789012345678901234567890
!    &                                                                  &
