
//#include <stdlib.h>
//#include <stdio.h>
//#include <stdarg.h>
//#include <memory.h>
#include "MPIinclude.h"
#include "globals.h"
#include "ProcTree.h"
#include "Procs.h"

extern "C" {
  #include "armci.h"
}

void malloc_rm(void* ptrs [], MPI_Comm* apg_comm, const int bytes) {

  // Note `apg_comm' is a OUT parameter.
  // Its only role is to be passed to the matching `free_apg'.

  // `ptrs' is indexed by absolute physical id (*not* by id relative to `apg').

  const int napg = apg.size() ;
  int i ;

  int* ids = new int [napg] ;
  for(i = 0 ; i < napg ; i++)
    ids [i] = apg.id_abs(i) ;

  void** grp_ptrs = new void* [napg] ;

  MPI_Group world_group ;  // Could be a global ``constant''.
  MPI_Comm_group(MPI_COMM_WORLD, &world_group) ;

  MPI_Group apg_group ;

  MPI_Group_incl(world_group, napg, ids, &apg_group) ;
  MPI_Comm_create(MPI_COMM_WORLD, apg_group, apg_comm) ;

  ARMCI_MPI_Malloc(*apg_comm, grp_ptrs, bytes) ;

  MPI_Group_free(&apg_group) ;

  MPI_Group_free(&world_group) ;

  for(i = 0 ; i < napg ; i++)
    ptrs [ids[i]] = grp_ptrs [i] ;

  delete [] grp_ptrs ;

  delete [] ids ;
}

void free_rm(void* ptrs [], MPI_Comm* apg_comm) {
  ARMCI_MPI_Free(*apg_comm, ptrs [AdlibLocId()]) ;
  MPI_Comm_free(apg_comm) ;
}

