/*----------------------------------------------*/
/* Flags for 'mapvec (0)' (the 'attrs' word)	*/
/*----------------------------------------------*/
/*--------------------------------------------------------------*/
/* The following fields must accommodate values <= MAX_RANK,	*/
/* i.e. 7 with current Fortran rules, so they're 3 bits wide.	*/
/*--------------------------------------------------------------*/
#define  MA_ARRAY_RANK_MASK	0x7	/* field for 'array_rank' */
#define  MA_EMBED_RANK_MASK	0x38	/*   "    "  'embed_rank'*/

/*--------------------------------------------------------------*/
/* 'xxx_SHIFT' is the number of bits that a value must be	*/
/* shifted (left) to reach its field in 'attrs'.		*/
/*--------------------------------------------------------------*/
#define  MA_ARRAY_RANK_SHIFT	0	/* shift for 'array_rank' */
#define  MA_EMBED_RANK_SHIFT	3	/*   "    "  'embed_rank'*/


/*----------------------------------------------*/
/* ONE of the next 3 flags is always set...	*/
/*----------------------------------------------*/
#define  MA_DISTRIB		0x40
#define  MA_GLOBALLY_REPLIC	0x80	/* globally replicated
					      (proc_sp == NULL) */
#define  MA_REPLIC_ON_PROCS	0x100	/* replicated over 'proc_sp'
					      (proc_sp != NULL)*/
/*--------------------------------------------------------*/
/* if any of the next 4 flags are set, so is 'MA_DISTRIB' */
/*--------------------------------------------------------*/
#define  MA_INHERITED		0x200	/* "INHERIT" -- nothing
					    known about mapping! */
#define MA_ALIGNED_WITH_INHERIT	0x400	/* "ALIGN -> INHERIT" */

#define  MA_INHERIT_FMT		0x800	/* "DISTRIBUTE *" */
#define  MA_INHERIT_PROCS	0x1000	/* "DISTRIBUTE ... ONTO *" */

/*------------------------------------------------------*/
/* 'mapp' for an assumed (or deferred!) shape array	*/
/*------------------------------------------------------*/
#define  MA_ASSUMED_SHAPE	0x2000

/*-----------------*/
/* Composite flags */
/*-----------------*/
#define  MA_INHERIT_MASK	(MA_INHERITED | MA_ALIGNED_WITH_INHERIT |\
				 MA_INHERIT_FMT | MA_INHERIT_PROCS)

/*------------------------------------------------------*/
/* Flags for 'mapvec (FMT)' -- unused in DBC code (?!)	*/
/*------------------------------------------------------*/
#define  DFMT_COLLAPSED		'\01'
#define  DFMT_BLOCK		'\02'
#define  DFMT_CYCLIC		'\04'
#define  DFMT_INHERIT		'\10'

