
#define LOGICAL int

extern "C" {
  void AD_INIT_ADLIB(int* nProcs) ;
  void AD_FINALIZE_ADLIB() ;

  void AD_STACK_ERR(int *stack_len) ;
  void AD_C_STACK_ERR(int *stack_len) ;

  void AD_INIT_PROCS(int* handle, int* rank, int* shape) ;
  void AD_DELETE_PROCS(int* handle) ;

  void AD_SPLIT(int* handle, int* subsize, int* subids) ;
  int AD_ON(int* handle) ;
  void AD_NO(int* handle) ;
  void AD_MYID(int* myid) ;

  void AD_PROC_COORD(int* handle, int* coords) ;
  void AD_SCALAR_PROC(int* handle, int* coords) ;
  void AD_REMAP_II(int* dst_dat, int* dst_atr,
                   int* src_dat, int* src_atr) ;
  void AD_REMAP_RR(float* dst_dat, int* dst_atr,
                   float* src_dat, int* src_atr) ;
  void AD_REMAP_DD(double* dst_dat, int* dst_atr,
                   double* src_dat, int* src_atr) ;
  void AD_REMAP_ZZ(COMPLEX* dst_dat, int* dst_atr,
                   COMPLEX* src_dat, int* src_atr) ;
  void AD_REMAP_LL(LOGICAL* dst_dat, int* dst_atr,
                   LOGICAL* src_dat, int* src_atr) ;

  void AD_GATHER_II(int* dst_dat, int* dst_atr,
                    int* src_dat, int* src_atr,
                    ...) ;
  void AD_GATHER_RR(float* dst_dat, int* dst_atr,
                    float* src_dat, int* src_atr,
                    ...) ;
  void AD_GATHER_DD(double* dst_dat, int* dst_atr,
                    double* src_dat, int* src_atr,
                    ...) ;
  void AD_GATHER_ZZ(COMPLEX* dst_dat, int* dst_atr,
                    COMPLEX* src_dat, int* src_atr,
                    ...) ;
  void AD_GATHER_LL(LOGICAL* dst_dat, int* dst_atr,
                    LOGICAL* src_dat, int* src_atr,
                    ...) ;

  void AD_SCATTER_II(int* src_dat, int* src_atr,
                     int* dst_dat, int* dst_atr,
                     ...) ;
  void AD_SCATTER_RR(float* src_dat, int* src_atr,
                      float* dst_dat, int* dst_atr,
                      ...) ;
  void AD_SCATTER_DD(double* src_dat, int* src_atr,
                     double* dst_dat, int* dst_atr,
                     ...) ;
  void AD_SCATTER_ZZ(COMPLEX* src_dat, int* src_atr,
                     COMPLEX* dst_dat, int* dst_atr,
                     ...) ;
  void AD_SCATTER_LL(LOGICAL* src_dat, int* src_atr,
                     LOGICAL* dst_dat, int* dst_atr,
                     ...) ;

  void AD_SCATTER_MASK_II(int* src_dat, int* src_atr,
                          int* dst_dat, int* dst_atr,
                          int* msk_dat, int* msk_atr,
                          ...) ;
  void AD_SCATTER_MASK_RR(float* src_dat, int* src_atr,
                          float* dst_dat, int* dst_atr,
                          int* msk_dat, int* msk_atr,
                          ...) ;
  void AD_SCATTER_MASK_DD(double* src_dat, int* src_atr,
                          double* dst_dat, int* dst_atr,
                          int* msk_dat, int* msk_atr,
                          ...) ;
  void AD_SCATTER_MASK_ZZ(COMPLEX* src_dat, int* src_atr,
                          COMPLEX* dst_dat, int* dst_atr,
                          int* msk_dat, int* msk_atr,
                          ...) ;
  void AD_SCATTER_MASK_LL(LOGICAL* src_dat, int* src_atr,
                          LOGICAL* dst_dat, int* dst_atr,
                          int* msk_dat, int* msk_atr,
                          ...) ;

  void AD_SPREAD_I(int* res_dat, int* res_atr,
                   int* src_dat, int* src_atr,
                   int* dim, int* ncopies) ;
  void AD_SPREAD_R(float* res_dat, int* res_atr,
                   float* src_dat, int* src_atr,
                   int* dim, int* ncopies) ;
  void AD_SPREAD_D(double* res_dat, int* res_atr,
                   double* src_dat, int* src_atr,
                   int* dim, int* ncopies) ;
  void AD_SPREAD_Z(COMPLEX* res_dat, int* res_atr,
                   COMPLEX* src_dat, int* src_atr,
                   int* dim, int* ncopies) ;
  void AD_SPREAD_L(LOGICAL* res_dat, int* res_atr,
                   LOGICAL* src_dat, int* src_atr,
                   int* dim, int* ncopies) ;

  void AD_TRANSPOSE_I(int* res_dat, int* res_atr,
                      int* src_dat, int* src_atr) ;
  void AD_TRANSPOSE_R(float* res_dat, int* res_atr,
                      float* src_dat, int* src_atr) ;
  void AD_TRANSPOSE_D(double* res_dat, int* res_atr,
                      double* src_dat, int* src_atr) ;
  void AD_TRANSPOSE_Z(COMPLEX* res_dat, int* res_atr,
                      COMPLEX* src_dat, int* src_atr) ;
  void AD_TRANSPOSE_L(LOGICAL* res_dat, int* res_atr,
                      LOGICAL* src_dat, int* src_atr) ;

  void AD_CSHIFT_S_I(int* res_dat, int* res_atr,
                     int* src_dat, int* src_atr,
                     int* shf, int* dim) ;
  void AD_CSHIFT_S_R(float* res_dat, int* res_atr,
                     float* src_dat, int* src_atr,
                     int* shf, int* dim) ;
  void AD_CSHIFT_S_D(double* res_dat, int* res_atr,
                     double* src_dat, int* src_atr,
                     int* shf, int* dim) ;
  void AD_CSHIFT_S_Z(COMPLEX* res_dat, int* res_atr,
                     COMPLEX* src_dat, int* src_atr,
                     int* shf, int* dim) ;
  void AD_CSHIFT_S_L(LOGICAL* res_dat, int* res_atr,
                     LOGICAL* src_dat, int* src_atr,
                     int* shf, int* dim) ;

  void AD_CSHIFT_A_I(int* res_dat, int* res_atr,
                     int* src_dat, int* src_atr,
                     int* shf_dat, int* shf_atr, int* dim) ;
  void AD_CSHIFT_A_R(float* res_dat, int* res_atr,
                     float* src_dat, int* src_atr,
                     int* shf_dat, int* shf_atr, int* dim) ;
  void AD_CSHIFT_A_D(double* res_dat, int* res_atr,
                     double* src_dat, int* src_atr,
                     int* shf_dat, int* shf_atr, int* dim) ;
  void AD_CSHIFT_A_Z(COMPLEX* res_dat, int* res_atr,
                     COMPLEX* src_dat, int* src_atr,
                     int* shf_dat, int* shf_atr, int* dim) ;
  void AD_CSHIFT_A_L(LOGICAL* res_dat, int* res_atr,
                     LOGICAL* src_dat, int* src_atr,
                     int* shf_dat, int* shf_atr, int* dim) ;

  void AD_EOSHIFT_SS_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* shf, int* bdr, int* dim) ;
  void AD_EOSHIFT_SS_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* shf, float* bdr, int* dim) ;
  void AD_EOSHIFT_SS_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* shf, double* bdr, int* dim) ;
  void AD_EOSHIFT_SS_Z(COMPLEX* res_dat, int* res_atr,
                       COMPLEX* src_dat, int* src_atr,
                       int* shf, COMPLEX* bdr, int* dim) ;
  void AD_EOSHIFT_SS_L(LOGICAL* res_dat, int* res_atr,
                       LOGICAL* src_dat, int* src_atr,
                       int* shf, LOGICAL* bdr, int* dim) ;

  void AD_EOSHIFT_SA_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* shf, int* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_SA_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* shf, float* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_SA_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* shf, double* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_SA_Z(COMPLEX* res_dat, int* res_atr,
                       COMPLEX* src_dat, int* src_atr,
                       int* shf, COMPLEX* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_SA_L(LOGICAL* res_dat, int* res_atr,
                       LOGICAL* src_dat, int* src_atr,
                       int* shf, LOGICAL* bdr_dat, int* bdr_atr, int* dim) ;

  void AD_EOSHIFT_AS_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr, int* bdr, int* dim) ;
  void AD_EOSHIFT_AS_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr, float* bdr, int* dim) ;
  void AD_EOSHIFT_AS_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr, double* bdr, int* dim) ;
  void AD_EOSHIFT_AS_Z(COMPLEX* res_dat, int* res_atr,
                       COMPLEX* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr, COMPLEX* bdr, int* dim) ;
  void AD_EOSHIFT_AS_L(LOGICAL* res_dat, int* res_atr,
                       LOGICAL* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr, LOGICAL* bdr, int* dim) ;

  void AD_EOSHIFT_AA_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr,
                       int* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_AA_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr,
                       float* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_AA_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr,
                       double* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_AA_Z(COMPLEX* res_dat, int* res_atr,
                       COMPLEX* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr,
                       COMPLEX* bdr_dat, int* bdr_atr, int* dim) ;
  void AD_EOSHIFT_AA_L(LOGICAL* res_dat, int* res_atr,
                       LOGICAL* src_dat, int* src_atr,
                       int* shf_dat, int* shf_atr,
                       LOGICAL* bdr_dat, int* bdr_atr, int* dim) ;


  void AD_RESHAPE_I(int* res_dat, int* res_atr,
                    int* src_dat, int* src_atr,
                    int* shp_dat, int* shp_atr,
                    int* pad_dat, int* pad_atr, int* pad_present,
                    int* ord_dat, int* ord_atr, int* ord_present) ;
  void AD_RESHAPE_R(float* res_dat, int* res_atr,
                    float* src_dat, int* src_atr,
                    int* shp_dat, int* shp_atr,
                    float* pad_dat, int* pad_atr, int* pad_present,
                    int* ord_dat, int* ord_atr, int* ord_present) ;
  void AD_RESHAPE_D(double* res_dat, int* res_atr,
                    double* src_dat, int* src_atr,
                    int* shp_dat, int* shp_atr,
                    double* pad_dat, int* pad_atr, int* pad_present,
                    int* ord_dat, int* ord_atr, int* ord_present) ;
  void AD_RESHAPE_Z(COMPLEX* res_dat, int* res_atr,
                    COMPLEX* src_dat, int* src_atr,
                    int* shp_dat, int* shp_atr,
                    COMPLEX* pad_dat, int* pad_atr, int* pad_present,
                    int* ord_dat, int* ord_atr, int* ord_present) ;
  void AD_RESHAPE_L(LOGICAL* res_dat, int* res_atr,
                    LOGICAL* src_dat, int* src_atr,
                    int* shp_dat, int* shp_atr,
                    LOGICAL* pad_dat, int* pad_atr, int* pad_present,
                    int* ord_dat, int* ord_atr, int* ord_present) ;

  void AD_DOT_PRODUCT_II(int* r,
                         int* a_dat, int* a_atr,
                         int* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_IR(float* r,
                         int* a_dat, int* a_atr,
                         float* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_ID(double* r,
                         int* a_dat, int* a_atr,
                         double* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_IZ(COMPLEX* r,
                         int* a_dat, int* a_atr,
                         COMPLEX* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_RI(float* r,
                         float* a_dat, int* a_atr,
                         int* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_RR(float* r,
                         float* a_dat, int* a_atr,
                         float* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_RD(double* r,
                         float* a_dat, int* a_atr,
                         double* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_RZ(COMPLEX* r,
                         float* a_dat, int* a_atr,
                         COMPLEX* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_DI(double* r,
                         double* a_dat, int* a_atr,
                         int* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_DR(double* r,
                         double* a_dat, int* a_atr,
                         float* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_DD(double* r,
                         double* a_dat, int* a_atr,
                         double* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_DZ(COMPLEX* r,
                         double* a_dat, int* a_atr,
                         COMPLEX* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_ZI(COMPLEX* r,
                         COMPLEX* a_dat, int* a_atr,
                         int* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_ZR(COMPLEX* r,
                         COMPLEX* a_dat, int* a_atr,
                         float* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_ZD(COMPLEX* r,
                         COMPLEX* a_dat, int* a_atr,
                         double* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_ZZ(COMPLEX* r,
                         COMPLEX* a_dat, int* a_atr,
                         COMPLEX* b_dat, int* b_atr) ;
  void AD_DOT_PRODUCT_LL(int* r,
                         int* a_dat, int* a_atr,
                         int* b_dat, int* b_atr) ;

  void AD_MATMUL_II(int* r_dat, int* r_atr,
                    int* a_dat, int* a_atr, int* b_dat, int* b_atr) ;
  void AD_MATMUL_IR(float* r_dat, int* r_atr,
                    int* a_dat, int* a_atr, float* b_dat, int* b_atr) ;
  void AD_MATMUL_ID(double* r_dat, int* r_atr,
                    int* a_dat, int* a_atr, double* b_dat, int* b_atr) ;
  void AD_MATMUL_IZ(COMPLEX* r_dat, int* r_atr,
                    int* a_dat, int* a_atr, COMPLEX* b_dat, int* b_atr) ;
  void AD_MATMUL_RI(float* r_dat, int* r_atr,
                    float* a_dat, int* a_atr, int* b_dat, int* b_atr) ;
  void AD_MATMUL_RR(float* r_dat, int* r_atr,
                    float* a_dat, int* a_atr, float* b_dat, int* b_atr) ;
  void AD_MATMUL_RD(double* r_dat, int* r_atr,
                    float* a_dat, int* a_atr, double* b_dat, int* b_atr) ;
  void AD_MATMUL_RZ(COMPLEX* r_dat, int* r_atr,
                    float* a_dat, int* a_atr, COMPLEX* b_dat, int* b_atr) ;
  void AD_MATMUL_DI(double* r_dat, int* r_atr,
                    double* a_dat, int* a_atr, int* b_dat, int* b_atr) ;
  void AD_MATMUL_DR(double* r_dat, int* r_atr,
                    double* a_dat, int* a_atr, float* b_dat, int* b_atr) ;
  void AD_MATMUL_DD(double* r_dat, int* r_atr,
                    double* a_dat, int* a_atr, double* b_dat, int* b_atr) ;
  void AD_MATMUL_DZ(COMPLEX* r_dat, int* r_atr,
                    double* a_dat, int* a_atr, COMPLEX* b_dat, int* b_atr) ;
  void AD_MATMUL_ZI(COMPLEX* r_dat, int* r_atr,
                    COMPLEX* a_dat, int* a_atr, int* b_dat, int* b_atr) ;
  void AD_MATMUL_ZR(COMPLEX* r_dat, int* r_atr,
                    COMPLEX* a_dat, int* a_atr, float* b_dat, int* b_atr) ;
  void AD_MATMUL_ZD(COMPLEX* r_dat, int* r_atr,
                    COMPLEX* a_dat, int* a_atr, double* b_dat, int* b_atr) ;
  void AD_MATMUL_ZZ(COMPLEX* r_dat, int* r_atr,
                    COMPLEX* a_dat, int* a_atr, COMPLEX* b_dat, int* b_atr) ;
  void AD_MATMUL_LL(LOGICAL* r_dat, int* r_atr,
                    LOGICAL* a_dat, int* a_atr, LOGICAL* b_dat, int* b_atr) ;


  void AD_ALL(int* r, int* msk_dat, int* msk_atr) ;
  void AD_ANY(int* r, int* msk_dat, int* msk_atr) ;
  void AD_COUNT(int* r, int* msk_dat, int* msk_atr) ;
  void AD_ALL_DIM(int* r_dat, int* r_atr, int* msk_dat, int* msk_atr,
                  int* dim) ;
  void AD_ANY_DIM(int* r_dat, int* r_atr, int* msk_dat, int* msk_atr,
                  int* dim) ;
  void AD_COUNT_DIM(int* r_dat, int* r_atr, int* msk_dat, int* msk_atr,
                    int* dim) ;

  void AD_MAXVAL_I(int* res, int* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXVAL_R(float* res, float* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXVAL_D(double* res, double* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_MINVAL_I(int* res, int* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINVAL_R(float* res, float* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINVAL_D(double* res, double* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_SUM_I(int* res, int* src_dat, int* src_atr,
                int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_R(float* res, float* src_dat, int* src_atr,
                int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_D(double* res, double* src_dat, int* src_atr,
                int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_Z(COMPLEX* res, COMPLEX* src_dat, int* src_atr,
                int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_PRODUCT_I(int* res, int* src_dat, int* src_atr,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_R(float* res, float* src_dat, int* src_atr,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_D(double* res, double* src_dat, int* src_atr,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_Z(COMPLEX* res, COMPLEX* src_dat, int* src_atr,
                    int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_MAXVAL_DIM_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXVAL_DIM_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXVAL_DIM_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_MINVAL_DIM_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINVAL_DIM_R(float* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINVAL_DIM_D(double* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_SUM_DIM_I(int* res_dat, int* res_atr,
                    int* src_dat, int* src_atr,
                    int* dim,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_DIM_R(float* res_dat, int* res_atr,
                    float* src_dat, int* src_atr,
                    int* dim,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_DIM_D(double* res_dat, int* res_atr,
                    double* src_dat, int* src_atr,
                    int* dim,
                    int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_SUM_DIM_Z(COMPLEX* res_dat, int* res_atr,
                    COMPLEX* src_dat, int* src_atr,
                    int* dim,
                    int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_PRODUCT_DIM_I(int* res_dat, int* res_atr,
                        int* src_dat, int* src_atr,
                        int* dim,
                        int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_DIM_R(float* res_dat, int* res_atr,
                        float* src_dat, int* src_atr,
                        int* dim,
                        int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_DIM_D(double* res_dat, int* res_atr,
                        double* src_dat, int* src_atr,
                        int* dim,
                        int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_PRODUCT_DIM_Z(COMPLEX* res_dat, int* res_atr,
                        COMPLEX* src_dat, int* src_atr,
                        int* dim,
                        int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_MAXLOC_I(int* res_dat, int* res_atr,
                   int* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXLOC_R(int* res_dat,   int* res_atr,
                   float* src_dat, int* src_atr,
                   int* msk_dat,   int* msk_atr, int* msk_present) ;
  void AD_MAXLOC_D(int* res_dat,    int* res_atr,
                   double* src_dat, int* src_atr,
                   int* msk_dat,    int* msk_atr, int* msk_present) ;

  void AD_MINLOC_I(int* res_dat, int* res_atr,
                   int* src_dat, int* src_atr,
                   int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINLOC_R(int* res_dat,   int* res_atr,
                   float* src_dat, int* src_atr,
                   int* msk_dat,   int* msk_atr, int* msk_present) ;
  void AD_MINLOC_D(int* res_dat,    int* res_atr,
                   double* src_dat, int* src_atr,
                   int* msk_dat,    int* msk_atr, int* msk_present) ;

  void AD_MAXLOC_DIM_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXLOC_DIM_R(int* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MAXLOC_DIM_D(int* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;

  void AD_MINLOC_DIM_I(int* res_dat, int* res_atr,
                       int* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINLOC_DIM_R(int* res_dat, int* res_atr,
                       float* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
  void AD_MINLOC_DIM_D(int* res_dat, int* res_atr,
                       double* src_dat, int* src_atr,
                       int* dim,
                       int* msk_dat, int* msk_atr, int* msk_present) ;
}

