/*
 * File         : test2.java
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 11:08:32 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1998/09/29 19:48:25 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class test2 {
  public static void main(String argv[]) {
    SpmdEnv spmd=new SpmdEnv(argv);

    Procs1 p=new Procs1(4);

    BlockRange x = new BlockRange (32, p.dim(0));
    Array1Float a = new Array1Float(x, spmd.apg);

    BlockRange y = new BlockRange (200, p.dim(0));
    Array1Float b = new Array1Float(y, spmd.apg);

    if (p.on()) {

      Index j = new Index (y);

      j.dim().over();
      for (j.begin(); j.test(); j.next()) {
	b.data[b.element(j)]=1+y.idx(j);
      } j.dim().revo();

      Index i = new Index (x);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	a.data[a.element(i)]=1000*(1+x.idx(i));
      } i.dim().revo();

      Range xs=x.subrng(10, 9);
      Range ys=y.subrng(10,99,10);

      Adlib.remap(a.section(xs), b.section(ys));

    } p.no();

    Adlib.aprintf("%12.2f\n", a);    

    spmd.finalize();
  }
}
