/*
 * File         : test4.java
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 14:07:22 1998
 * Revision     : $Revision: 1.7 $
 * Updated      : $Date: 1998/09/29 19:48:26 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */


import spmd.*;

class test4 {
  public static void main(String argv[]) {
    SpmdEnv spmd=new SpmdEnv(argv);

    Procs1 p=new Procs1(4);

    if (p.on()) {

      BlockRange x = new BlockRange (10, p.dim(0));
      Array1Float u = new Array1Float(x, spmd.apg);

      Index i = new Index (x);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	if (x.idx(i)==0 || x.idx(i)==9)
	  u.data[u.element(i)]=1;
	else
	  u.data[u.element(i)]=0;
      } i.dim().revo();

      Range xc=x.subrng(8, 1, 1);      

      Array1Float uL=u.section(x.subrng(8,0));
      Array1Float uR=u.section(x.subrng(8,2));

      Array1Float tmp1= new Array1Float(xc, spmd.apg);
      Array1Float tmp2= new Array1Float(xc, spmd.apg);
      
      for (int n=1; n<=5; n++) {
	Adlib.remap(tmp1, uL);
	Adlib.remap(tmp2, uR);

	Index ic = new Index (xc);

	i.dim().over();
	for (ic.begin(); ic.test(); ic.next()) {
	  u.data[u.element(ic)]=(float)0.5*
	    (tmp1.data[tmp1.element(ic)]+tmp2.data[tmp2.element(ic)]);
	} ic.dim().revo();

	//Adlib.gprintf("iteration = %d\n", n);
	//Spmd.rout.println("iteration = "+n);
	Adlib.rprintln("iteration = "+n);
	Adlib.aprintf("%2R0%7.3f\n", u);

      }
    } p.no();

    spmd.finalize();
  }
}
