/*
 * File         : test7.java
 * Author       : Guansong Zhang
 * Created      : Wed Jan 14 11:18:22 1998
 * Revision     : $Revision: 1.4 $
 * Updated      : $Date: 1998/09/29 19:48:28 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class test7 {
  public static void main(String argv[]) {
    SpmdEnv spmd = new SpmdEnv(argv);

    Procs2 p=new Procs2(3,2);

    CyclicRange x = new CyclicRange (8, p.dim(0));
    Range y = new Range(4);
    Range z = new BlockRange(24, p.dim(0)).subrng(10,5,2);

    Array3Int a = new Array3Int(x, y, z, p);

    Procs2 q=new Procs2(3,2);
    
    Range r = new BlockRange(10, q.dim(0)).subrng(6,6,-1);
    BlockRange s =new BlockRange(4, p.dim(1));
    Range t = new Range(12);
    
    Array3Int b = new Array3Int(r, s, t, q);

    Array1Int u = new Array1Int(r, q);
    Array1Int v = new Array1Int(t, q);

    if (p.on()) {

      Index ix = new Index (x);
      Index iy = new Index (y);
      Index iz = new Index (z);

      ix.dim().over();
      for (ix.begin(); ix.test(); ix.next()) {
	iy.dim().over();
	for (iy.begin(); iy.test(); iy.next()) {
	  iz.dim().over();
	  for (iz.begin(); iz.test(); iz.next()) {
	    a.data[a.element(ix,iy,iz)]= 100*x.idx(ix) + 10*y.idx(iy) + z.idx(iz);
	  } iz.dim().revo();
	} iy.dim().revo();
      } ix.dim().revo();

    } p.no();

    if (q.on()) {
      
      Index ir = new Index (r);

      ir.dim().over();
      for (ir.begin(); ir.test(); ir.next()) {
	u.data[u.element(ir)] = (r.idx(ir) * 5) % 8;
      } ir.dim().revo();
      
      Index it = new Index (t);

      ir.dim().over();
      for (ir.begin(); ir.test(); ir.next()) {
	v.data[v.element(ir)] = t.idx(it) / 2 + 1;
      } ir.dim().revo();

    } q.no();


    Adlib.aprintf("%3R0%3R1%3R2%10d\n", b);

    spmd.finalize();

  }
}
 
