/*
 * File         : test0.hpj
 * Author       : Qiang Zheng
 * Created      : Wed Oct 14 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/11/01 18:25:12 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

// real a(32)
// !hpf$ distribute a (block) onto p
// !hpf$ processors p (4)
// 
// a(13) = 23.0
// 
// print *, a(13)
// 
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test0{
  public static void main(String argv[]) {

	SpmdEnv spmd = new SpmdEnv(argv);
	// spmd.Initialize(argv);

	hpjava.lang.Procs1 p = new hpjava.lang.Procs1(4);

	if (p.on()){

		hpjava.lang.Range x = new hpjava.lang.BlockRange(32,p.dim(0));	

		// Float[[]] a = new Float [[x]] on p;
		hpjava.lang.Array1dF a = new hpjava.lang.Array1dF(spmd.apg,x);
		
		hpjava.lang.Location s = x.location(12);
		if(s.at()) {
			a.dat()[a.pos(s)] = (float)23.0;
		} s.ta();

		Array0F as = new Array0F
			(p.divide(s),a.dat(),a.off()+a.str()[0].offset(s));
		//Adlib.aprintf("%f\n", a.section(s));
		Adlib.aprintf("%f\n", as);

	} p.no();

	spmd.finalize();
  }

}
