
//  logical a(6, 35)
//!hpf$ processors q(2, 3)
//!hpf$ template s(14, 100)
//!hpf$ distribute s(block, cyclic(12)) onto q
//!hpf$ align a(i, j) with s(2 * i, 90 - 2 * j) 
//
//  do i = 1, 6
//    do j = 1, 35
//      a(i, j) = .false.
//    enddo
//  enddo
//
//  a(1, 6)  = .true.
//  a(1, 12) = .true.
//  a(1, 25) = .true.
//
//  a(3, 35) = .true.
//
//  a(4, 1)  = .true.
//  a(4, 2)  = .true.
//
//  do j = 1, 35
//    a(5, j) = .true.
//  enddo
//
//  print '(" any =", 6l2)', any (a, 2)
//  print '(" all =", 6l2)', all (a, 2)
//  print '(" count =", 6i3)', count (a, 2)
//end

#include "ad++.h"

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 q(2, 3) ;

  BlockRange s1(14, q.dim(0)) ;
  BlockCyclicRange s2(100, q.dim(1), 12) ;

  Range x = s1.subrng(6, 1, 2) ;
  Range y = s2.subrng(35, 87, -2) ;

  Array2<int> a(x, y, q) ;

  ON(q) {
    Index i(x), j(y) ;

    OVERALL(i) {
      OVERALL(j) {
        a(i, j) = 0 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;

    Location k, l ;

    k = x(0) ;
    AT(k) {
      l = y(5) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;

      l = y(11) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;

      l = y(24) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;
    } TA(k) ;

    k = x(2) ;
    AT(k) {
      l = y(34) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;
    } TA(k) ;

    k = x(3) ;
    AT(k) {
      l = y(0) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;

      l = y(1) ;
      AT(l) {
        a(k, l) = 1 ;
      } TA(l) ;
    } TA(k) ;

    k = x(4) ;
    AT(k) {
      OVERALL(j) {
        a(k, j) = 1 ;
      } ALLOVER(j) ;
    } TA(k) ;
  } NO(p) ;

//  print '(" any =", 6l2)', any (a, 2)
//  print '(" all =", 6l2)', all (a, 2)
//  print '(" count =", 6i3)', count (a, 2)

  Array1<int> res(x, q) ;

  any(res, a, 1) ;

  gprintf("any = ") ;
  aprintf("%2d", res) ;
  gprintf("\n") ;

  all(res, a, 1) ;

  gprintf("all = ") ;
  aprintf("%2d", res) ;
  gprintf("\n") ;

  count(res, a, 1) ;

  gprintf("count = ") ;
  aprintf("%3d", res) ;
  gprintf("\n") ;

  AdlibFinalize() ;
}


