

//  !hpf$ processors q(2, 3)
//
//  !hpf$ template s(4, 100)
//  !hpf$ distribute s(block, cyclic(6)) onto q
//
//  integer a(80)
//  real b(80)
//  double precision c(80)
//  logical m(80)
//  !hpf$ align a(j) with s(2, 15 + j) 
//  !hpf$ align b(:) with a(:)
//  !hpf$ align c(:) with a(:)
//  !hpf$ align m(:) with a(:)
//
//  do i = 1, 80
//    if(i < 13) then
//      a(i) = i
//      b(i) = i
//      c(i) = i
//    else
//      a(i) = 1
//      b(i) = 1
//      c(i) = 1
//    endif
//    m(i) = .false.
//  enddo
//
//  m(3)  = .true.
//  m(5)  = .true.
//  m(7)  = .true.
//  m(9)  = .true.
//
//  print "(i15,f15.2,f15.2)", maxval(a), maxval(b), maxval(c)
//  print "(i15,f15.2,f15.2)", &
//        & maxval(a, mask = m), maxval(b, mask = m), maxval(c, mask = m)
//  print "(i15,f15.2,f15.2)", minval(a), minval(b), minval(c)
//  print "(i15,f15.2,f15.2)", &
//        & minval(a, mask = m), minval(b, mask = m), minval(c, mask = m)
//  print "(i15,f15.2,f15.2)", sum(a), sum(b), sum(c)
//  print "(i15,f15.2,f15.2)", &
//        & sum(a, mask = m), sum(b, mask = m), sum(c, mask = m)
//  print "(i15,f15.2,f15.2)", product(a), product(b), product(c)
//  print "(i15,f15.2,f15.2)", &
//        & product(a, mask = m), product(b, mask = m), product(c, mask = m)
//  print "(i15,i15,i15)", maxloc(a), maxloc(b), maxloc(c)
//  print "(i15,i15,i15)", &
//        & maxloc(a, mask = m), maxloc(b, mask = m), maxloc(c, mask = m)
//  print "(i15,i15,i15)", minloc(a), minloc(b), minloc(c)
//  print "(i15,i15,i15)", &
//        & minloc(a, mask = m), minloc(b, mask = m), minloc(c, mask = m)
//end


#include <stdio.h>
#include "ad++.h"

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

//  !hpf$ processors q(2, 3)
//
//  !hpf$ template s(4, 100)
//  !hpf$ distribute s(block, cyclic(6)) onto q
//
//  integer a(80)
//  real b(80)
//  double precision c(80)
//  logical m(80)
//  !hpf$ align a(j) with s(2, 15 + j) 
//  !hpf$ align b(:) with a(:)
//  !hpf$ align c(:) with a(:)
//  !hpf$ align m(:) with a(:)

  Procs2 q(2, 3) ;

  BlockRange s1(4,   q.dim(0)) ;
  //const int numBlocks = (100 + 5) / 6 ;
  //BlockRange s2(100, CyclicRange(numBlocks, q.dim(1))) ;
  BlockCyclicRange s2(100, q.dim(1), 6) ;

  Group r(q / s1(1)) ;
  Range x = s2.subrng(80, 15) ;

  Array1<int>    a(x, r) ;
  Array1<float>  b(x, r) ;
  Array1<double> c(x, r) ;
  Array1<int>    m(x, r) ;

//  do i = 1, 80
//    if(i < 13) then
//      a(i) = i
//      b(i) = i
//      c(i) = i
//    else
//      a(i) = 1
//      b(i) = 1
//      c(i) = 1
//    endif
//    m(i) = .false.
//  enddo
//
//  m(3)  = .true.
//  m(5)  = .true.
//  m(7)  = .true.
//  m(9)  = .true.

  ON(r) {
    Index i(x) ;
    OVERALL(i) {
      if(i + 1 < 13) {
        a(i) = i + 1 ;
        b(i) = i + 1 ;
        c(i) = i + 1 ;
      }
      else {
        a(i) = 1 ;
        b(i) = 1 ;
        c(i) = 1 ;
      }
      m(i) = 0 ;
    } ALLOVER(i) ;

    { Location s = x(2) ;
      AT(s) m(s) = 1 ; TA(s) ;
    }
    
    { Location s = x(4) ;
      AT(s) m(s) = 1 ; TA(s) ;
    }
    
    { Location s = x(6) ;
      AT(s) m(s) = 1 ; TA(s) ;
    }
    
    { Location s = x(8) ;
      AT(s) m(s) = 1 ; TA(s) ;
    }
  } NO(r) ;

//  print "(i15,f15.2,f15.2)", maxval(a), maxval(b), maxval(c)

  gprintf("%15d%15.2f%15.2f\n", maxval(a), maxval(b), maxval(c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & maxval(a, mask = m), maxval(b, mask = m), maxval(c, mask = m)

  gprintf("%15d%15.2f%15.2f\n", maxval(a, m), maxval(b, m), maxval(c, m)) ;

//  print "(i15,f15.2,f15.2)", minval(a), minval(b), minval(c)

  gprintf("%15d%15.2f%15.2f\n", minval(a), minval(b), minval(c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & minval(a, mask = m), minval(b, mask = m), minval(c, mask = m)

  gprintf("%15d%15.2f%15.2f\n", minval(a, m), minval(b, m), minval(c, m)) ;

//  print "(i15,f15.2,f15.2)", sum(a), sum(b), sum(c)

  gprintf("%15d%15.2f%15.2f\n", sum(a), sum(b), sum(c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & sum(a, mask = m), sum(b, mask = m), sum(c, mask = m)

  gprintf("%15d%15.2f%15.2f\n", sum(a, m), sum(b, m), sum(c, m)) ;

//  print "(i15,f15.2,f15.2)", product(a), product(b), product(c)

  gprintf("%15d%15.2f%15.2f\n", product(a), product(b), product(c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & product(a, mask = m), product(b, mask = m), product(c, mask = m)

  gprintf("%15d%15.2f%15.2f\n", product(a, m), product(b, m), product(c, m)) ;

//  print "(i15,f15.2,f15.2)", &
//        & all(m), any(m), count(m)

  gprintf("%15d%15d%15d\n", all(m), any(m), count(m)) ;


//  print "(i15,i15,i15)", maxloc(a), maxloc(b), maxloc(c)

  int aloc [1], bloc [1], cloc [1] ;
  int aval ;
  float bval ;
  double cval ;

  // Odd-looking casts of `aloc', etc, are work-arounds for DEC compiler.

  maxloc(&aval, (int*) aloc, a) ;
  maxloc(&bval, (int*) bloc, b) ;
  maxloc(&cval, (int*) cloc, c) ;

  gprintf("%6d(%7d)%6d(%7.2f)%6d(%7.2f)\n",
          aloc [0], aval, bloc [0], bval, cloc [0], cval) ;

//  print "(i15,i15,i15)", &
//        & maxloc(a, mask = m), maxloc(b, mask = m), maxloc(c, mask = m)

  maxloc(&aval, (int*) aloc, a, m) ;
  maxloc(&bval, (int*) bloc, b, m) ;
  maxloc(&cval, (int*) cloc, c, m) ;

  gprintf("%6d(%7d)%6d(%7.2f)%6d(%7.2f)\n",
          aloc [0], aval, bloc [0], bval, cloc [0], cval) ;

//  print "(i15,i15,i15)", minloc(a), minloc(b), minloc(c)

  minloc(&aval, (int*) aloc, a) ;
  minloc(&bval, (int*) bloc, b) ;
  minloc(&cval, (int*) cloc, c) ;

  gprintf("%6d(%7d)%6d(%7.2f)%6d(%7.2f)\n",
          aloc [0], aval, bloc [0], bval, cloc [0], cval) ;

//  print "(i15,i15,i15)", &
//        & minloc(a, mask = m), minloc(b, mask = m), minloc(c, mask = m)

  minloc(&aval, (int*) aloc, a, m) ;
  minloc(&bval, (int*) bloc, b, m) ;
  minloc(&cval, (int*) cloc, c, m) ;

  gprintf("%6d(%7d)%6d(%7.2f)%6d(%7.2f)\n",
          aloc [0], aval, bloc [0], bval, cloc [0], cval) ;

//  print "(i15,f15.2,f15.2)", &
//        & dot_product(a, a), dot_product(a, b), dot_product(a, c)

  gprintf("%15d%15.2f%15.2f\n",
          dotProduct(a, a), dotProduct(a, b), dotProduct(a, c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & dot_product(b, a), dot_product(b, b), dot_product(b, c)

  gprintf("%15.2f%15.2f%15.2f\n",
          dotProduct(b, a), dotProduct(b, b), dotProduct(b, c)) ;

//  print "(i15,f15.2,f15.2)", &
//        & dot_product(c, a), dot_product(c, b), dot_product(c, c)

  gprintf("%15.2f%15.2f%15.2f\n",
          dotProduct(c, a), dotProduct(c, b), dotProduct(c, c)) ;


  AdlibFinalize() ;
}


// -------------------------------------------------------------
// Things to do
//

