
// real a(10, 10), b(10, 10)
// 
// !hpf$ distribute a (block, block) onto p
// !hpf$ align b (i, j) with a (j, i)
// !hpf$ processors p (2, 2)
// 
// do i = 1, 10
//   do j = 1, 10
//     a (i, j) = 10 * i + j
//   enddo
// enddo
// 
// b = a + 2
// 
// do i = 1, 10
//   print "(10f7.1)", b(i, :)
// enddo
// 
// end


#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(2, 2) ;


  ON(p) {
    BlockRange x(10, p.dim(0)) ;
    BlockRange y(10, p.dim(1)) ;

    Array2<float> a(x, y), b(y, x) ;

    Index i(x), j(y) ;

    OVERALL(i) {
      OVERALL(j) {
        a(i, j) = 10 * (1 + i) + 1 + j ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;

    Array2<float> tmp1(x, y) ;
    OVERALL(i) {
      OVERALL(j) {
        tmp1(i, j) = a(i, j) + 2 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;

    remap(b, tmp1) ;

    aprintf("%7.1f%*N", b, x.size()) ;
  } NO(p) ;

  AdlibFinalize() ;
}


