
//   real u(10)
// 
//   !hpf$ distribute u (block) onto p
//   !hpf$ processors p (4)
// 
//   integer i
// 
//   do i = 1, 10
//     if(i .eq. 1 .or. i .eq. 10) then
//       u(i) = 1.0
//     else
//       u(i) = 0.0
//     endif
//   enddo
// 
//   do n = 1, 5
//     u(2 : 9) = 0.5 * (u(1 : 8) + u(3 : 10))
//     print *, "iteration =", n
//     do i = 1, 10
//       print "(i2, f7.3)", i, u(i)
//     enddo
//   enddo
// 
// end


#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs1 p(4) ;

  ON(p) {
    BlockRange x(10, p.dim(0)) ;

    Array1<float> u(x) ;

    Index i(x) ;
    OVERALL(i) {
      if(i == 0 || i == 9)
	u(i) = 1.0 ;
      else
        u(i) = 0.0 ;
    } ALLOVER(i) ;

    Range xc = x.subrng(8, 1, 1) ;

    Section1<float> uL = u.sect(Trip(0, 7)) ;  // uL ~ u (1 : 8)
    Section1<float> uR = u.sect(Trip(2, 9)) ;  // uR ~ u (3 : 10) 

    Array1<float> tmp1(xc) ;
    Array1<float> tmp2(xc) ; 

    for(int n = 1 ; n <= 5 ; n++) {
      remap(tmp1, uL) ;
      remap(tmp2, uR) ;

      Index ic(xc) ;
      OVERALL(ic)
	u(ic) = 0.5 * (tmp1(ic) + tmp2(ic)) ;
      ALLOVER(ic) ;

      gprintf("iteration = %d\n", n) ;
      aprintf("%2R0%7.3f\n", u) ;
    }
  } NO(p) ;

  AdlibFinalize() ;
}


