
//   !hpf$ processors q(2, 3)
// 
//   !hpf$ template s(4, 100)
//   !hpf$ distribute s(block, cyclic(12)) onto q
// 
//   integer a(80)
//   real b(80)
//   !hpf$ align a(j) with s(*, 15 + j) 
//   !hpf$ align b(:) with a(:)
// 
//   double precision res
// 
//   do i = 1, 80
//     a(i) = i
//     b(i) = 1.0 / i
//   enddo
// 
//   res = dot_product(a, b)
// 
//   print *, res
// 
// end


#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 q(2, 3) ;

  //const int numBlocks = (100 + 11) / 12 ;
  //Range y = BlockRange(100, CyclicRange(numBlocks, q.dim(1))).subrng(80, 15) ;
  Range y = BlockCyclicRange(100, q.dim(1), 12).subrng(80, 15) ;

  Array1<int> a(y, q) ;
  Array1<float> b(y, q) ;

  ON(q) {
    Index j(y) ;
    OVERALL(j) {
      a(j) = j + 1 ;
      b(j) = 1.0 / (j + 1) ;
    } ALLOVER(j) ;
  } NO(q) ;

  gprintf("%f\n", dotProduct(a, b)) ;

  AdlibFinalize() ;
}


// -------------------------------------------------------------
// Things to do
//

