

// Test level 0 ranges.

#include <stdio.h>
#include <string.h>

#include "ad++.h"


const int n_cases = 3 ;

const int n = 6 ;

Range sample(char* desc, Dimension d, int i_case) {
  Range x ;

  switch(i_case) {
    case 0 :
      x = BlockRange(10, d).subrng(6, 0) ;
      strcpy(desc, "BlockRange(10, d).subrng(6)") ;
      break ;
    case 1 :
      x = CyclicRange(10, d).subrng(6, 0) ;
      strcpy(desc, "CyclicRange(10, d).subrng(6)") ;
      break ;
    case 2 :
      //x = Range(d) ;
      x = DimRange(d) ;
      strcpy(desc, "DimRange(d)") ;
      break ;
  }
  return x ;
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  char xDesc [1024], yDesc [1024] ;

  Procs1 p(n) ;
  Dimension d = p.dim(0) ;

  for(int i = 0 ; i < n_cases ; i++) {
    Range x = sample(xDesc, d, i) ;
    for(int j = 0 ; j < n_cases ; j++) {
      Range y = sample(yDesc, d, j) ;

      gprintf("x = %s\n", xDesc) ;
      gprintf("y = %s\n", yDesc) ;

      Array1<float> a(x, p) ;
      Array1<float> b(y, p) ;
      Array1<int> mask1(y, p), mask2(y, p) ;

      ON(p) {
        Index i(x) ;
        OVERALL(i) {
          a(i) = i ;
        } ALLOVER(i) ;
      } NO(p) ;

      remap(b, a) ;

      aprintf("%2R0  %f\n", b) ;

      ON(p) {
        Index i(y) ;
	OVERALL(i) {
	  mask1(i) = b(i) == i ;
	  mask2(i) = b(i) != i ;
	} ALLOVER(i) ;
      } NO(p) ;

      if(!all(mask1) || any(mask2))
	    // Do both checks to reduce chance of bug in reductions.
	gprintf("Error!\n") ;
      else
	gprintf("Checked OK\n") ;
    }
  }

  AdlibFinalize() ;
}


