

#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(3, 2) ;

  BlockRange t1(100, p.dim(0)) ;
  BlockCyclicRange t2(100, p.dim(1), 10) ;

  Range x = t1.subrng(20, 15, 3) ;
  Range y = t2.subrng(15, 25, 5) ;

  Array2<int> a(x, y, p) ;

  //Range i(10) ;
  CollapsedRange i(10) ;
  Range j = t2.subrng(20, 70, -2) ;

  Array2<int> b(i, j, p), u(i, j, p), v(i, j, p), mask(i, j, p) ;

  ON(p) {
    Index ix(x), iy(y) ;
    OVERALL(ix) {
      OVERALL(iy) {
	a(ix, iy) = 1000 * ix + iy ;
      } ALLOVER(iy) ;
    } ALLOVER(ix) ;

    Index ii(i), ij(j) ;
    OVERALL(ii) {
      OVERALL(ij) {
	b(ii, ij) = 0 ;
	u(ii, ij) = (ii + ij) % 20 ;
	v(ii, ij) = (ii + (30 - ij)) % 15 ;
	mask(ii, ij) = (ii + ij) % 2 ;
      } ALLOVER(ij) ;
    } ALLOVER(ii) ;
  } NO(p) ;

  //gather(b, a, u, v) ;
  gather(b, a, u, v, mask) ;

  aprintf("%3R0%3R1%10d\n", b) ;

  AdlibFinalize() ;
}

