


#include <stdio.h>

#include "ad++.h"

void accumInt(void* acc, void* val) {
  *((int*) acc) += *((int*) val) ;
}

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(3, 2) ;

  BlockRange t1(100, p.dim(0)) ;
  BlockCyclicRange t2(100, p.dim(1), 20) ;

  Range x = t1.subrng(20, 15, 3) ;
  Range y = t2.subrng(15, 25, 5) ;

  Array2<int> a(x, y, p) ;

  CollapsedRange i(10) ;
  Range j = t2.subrng(20, 70, -2) ;

  Array2<int> b(i, j, p), u(i, j, p), v(i, j, p) ;

  ON(p) {
    Index ix(x), iy(y) ;
    OVERALL(ix) {
      OVERALL(iy) {
	a(ix, iy) = 1000 * ix + iy ;
      } ALLOVER(iy) ;
    } ALLOVER(ix) ;

    Index ii(i), ij(j) ;
    OVERALL(ii) {
      OVERALL(ij) {
        b(ii, ij) = 100 * ii + ij ;
	u(ii, ij) = (ii + ij) % 20 ;
	v(ii, ij) = (ii * ij) % 15 ;
      } ALLOVER(ij) ;
    } ALLOVER(ii) ;
  } NO(p) ;

  scatterComb(b, a, u, v, &accumInt) ;

  gprintf("b, u, v...\n") ;
  aprintf("%3R0%3R1%10d%10d%10d\n", b, u, v) ;

  gprintf("a...\n") ;
  aprintf("%3R0%3R1%10d\n", a) ;

  AdlibFinalize() ;
}


