
// real a(8, 8)
// !hpf$ distribute a (block, block) onto p
// !hpf$ processors p (2, 2)
// 
// a(2, 6) = 23.0
// 
// print *, a(2, 6)
// 
// end


#include "ad++.h"
#include "mpi.h"
#include "ArrayRM.h"

int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;
  ARMCI_Init() ;

  Procs2 p(2, 2) ;

  ON(p) {
    BlockRange x(8, p.dim(0)) ;
    BlockRange y(8, p.dim(1)) ;
    ArrayRM2<float> a(x, y) ;

    Location i(x(1)), j(y(5)) ;

    AT(i) {
      AT(j) {
	a(i, j) = 23.0 ;
      } TA(j) ;
    } TA(i) ;

    aprintf("%f\n", a.sect(i, j)) ;
  } NO(p) ;

  ARMCI_Finalize() ;
  AdlibFinalize() ;
}

