
//   !hpf$ processors p(2, 2)
// 
//   integer a(6, 4)
//   !hpf$ distribute a(block, block) onto p
// 
//   !hpf$ template s(10, 4)
//   !hpf$ distribute s(cyclic, block) onto p
// 
//   integer b(6, 4)
//   !hpf$ align b(i, j) with s(1 + i, j)
// 
//   integer i, j, k
// 
//   do i = 1, 6
//     do j = 1, 4
//       a(i, j) = 100 * (i - 1) + 10 * (j - 1)
//     enddo
//   enddo
// 
//   b = a
// 
//   do i = 1, 6
//     do j = 1, 4
//       print "(i3, i3, i10)", i - 1, j - 1, b(i, j)
//     enddo
//   enddo
// 
// end


#include <stdio.h>
#include "ad++.h"
#include "adrm.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;
  ARMCI_Init() ;

  Procs2 p(2, 2) ;
  ON(p) {
    BlockRange x(6, p.dim(0)) ;
    BlockRange y(4, p.dim(1)) ;
    ArrayRM2<int> a(x, y) ;

    Range z = CyclicRange(10, p.dim(0)).subrng(6, 1) ;
    Array2<int> b(z, y) ;

    Index i(x), j(y) ;
    OVERALL(i) {
      OVERALL(j) {
        a(i, j) = 100 * i + 10 * j ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;

    remapRM(b, a) ;

    aprintf("%3R0%3R1%10d\n", b) ;
  } NO(p) ;

  ARMCI_Finalize() ;
  AdlibFinalize() ;
}


